//----------------------------------------------------------------------------
//  Project Owlgl
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Owlgl Application
//  FILE:         OwlglAbD.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TOwlglAboutDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(owlglabd_h)              // Sentry, use file only if it's not already included.
#define owlglabd_h

#include <owl/static.h>

#include "OwlglApp.rh"                  // Definition of all resources.


//{{TDialog = TOwlglAboutDlg}}
class TOwlglAboutDlg : public TDialog {
  public:
    TOwlglAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);
    virtual ~TOwlglAboutDlg();

//{{TOwlglAboutDlgVIRTUAL_BEGIN}}
  public:
    void SetupWindow();
//{{TOwlglAboutDlgVIRTUAL_END}}
};    //{{TOwlglAboutDlg}}


// Reading the VERSIONINFO resource.
//
class TProjectRCVersion {
  public:
    TProjectRCVersion(TModule* module);
    virtual ~TProjectRCVersion();

    bool GetProductName(LPSTR& prodName);
    bool GetProductVersion(LPSTR& prodVersion);
    bool GetCopyright(LPSTR& copyright);
    bool GetDebug(LPSTR& debug);

  protected:
    uint8 far*  TransBlock;
    void far*   FVData;

  private:
    // Don't allow this object to be copied.
    //
    TProjectRCVersion(const TProjectRCVersion&);
    TProjectRCVersion& operator = (const TProjectRCVersion&);
};


#endif  // owlglabd_h sentry.
