//----------------------------------------------------------------------------
//  Project Owlgl
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Owlgl Application
//  FILE:         OwlglApp.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TOwlglApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(owlglapp_h)              // Sentry, use file only if it's not already included.
#define owlglapp_h



#include "OwlglApp.rh"            // Definition of all resources.
#include <gl\gl.h>
#include <gl\glu.h>

//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TSDIDecFrameRSP_TBL_BEGIN}}
  protected:
  bool EvQueryNewPalette();
  void EvPaletteChanged(HWND hWndPalChg);
//{{TSDIDecFrameRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TSDIDecFrame);
};    //{{TSDIDecFrame}}


//{{TApplication = TOwlglApp}}
class TOwlglApp : public TApplication {
  private:


  public:
    TOwlglApp();
    virtual ~TOwlglApp();

//{{TOwlglAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TOwlglAppVIRTUAL_END}}

//{{TOwlglAppRSP_TBL_BEGIN}}
  protected:
    void EvNewView(TView& view);
    void EvCloseView(TView& view);
    void CmHelpAbout();
//{{TOwlglAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TOwlglApp);
};    //{{TOwlglApp}}


#endif  // owlglapp_h sentry.
