//----------------------------------------------------------------------------
//  Project Owlgl
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Owlgl Application
//  FILE:         OwlglWnV.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TOwlglWindowView (TWindowView).
//
//----------------------------------------------------------------------------
#if !defined(owlglwnv_h)              // Sentry, use file only if it's not already included.
#define owlglwnv_h

#include <owl/docview.h>

#include "OwlglApp.rh"            // Definition of all resources.


//{{TWindowView = TOwlglWindowView}}
class TOwlglWindowView : public TWindowView {
  public:
    TOwlglWindowView(TDocument& doc, TWindow* parent = 0);
    virtual ~TOwlglWindowView();

    HGLRC m_hRC;		// Rendering context
    HDC m_hDC;		// Device context
    TPalette *m_pPalette;	// 3-3-2 Palette


    void SetupPalette(HDC hDC);

//{{TOwlglWindowViewRSP_TBL_BEGIN}}
  protected:
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  bool EvQueryNewPalette();
  void EvPaletteChanged(HWND hWndPalChg);
  void EvTimer(uint timerId);
//{{TOwlglWindowViewRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TOwlglWindowView);
};    //{{TOwlglWindowView}}


#endif  // owlglwnv_h sentry.
