unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, OleCtrls, WAITEGL;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    gl: TWaiteGLCtrl;
    procedure Button1Click(Sender: TObject);
    procedure glRender(Sender: TObject);
    procedure glSetupRC(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.glRender(Sender: TObject);
begin
     // Make the rendering context current
     gl.MakeCurrent();

     // Clear the background, and draw a teapot
     gl.Clear(gl.glColorBufferBit());
     gl.Color(0, 0, 255, 255);

     gl.auxWireTeapot(55.0);

     // Flush commands, free rendering context, and
     // swap buffers
     gl.Flush();
     gl.MakeNotCurrent();
     gl.SwapBuffers();
end;

procedure TForm1.glSetupRC(Sender: TObject);
begin
     // Make the Rendering context current
     gl.MakeCurrent();

     // Set the clear color, and viewing volume
     gl.ClearColor(0.0, 0.0, 0.0, 1.0);
     gl.LoadIdentity();
     gl.Ortho(-100,100,-100,100,-100,100);

     // Flush the commands and make the rendering context
     // not current
     gl.Flush();
     gl.MakeNotCurrent();
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     // Make rending context current, then
     // rotate the scene somewhat
     gl.MakeCurrent();
     gl.Rotate(5.0,0.0,1.0,0.5);
     gl.MakeNotCurrent();

     // Repaint the OCX
     gl.Invalidate();
end;

end.
