// ocxGl.cpp
// This file contains the wrappers for the gl library

#include "stdafx.h"
#include "WaiteGL.h"
#include "WaiteGLCtl.h"
#include "WaiteGLPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



////////////////////////////////////////////////////////
// Simple OpenGL mappings

// glFlush
void CWaiteGLCtrl::Flush() 
	{
	glFlush();
	}

// glClearColor
void CWaiteGLCtrl::ClearColor(float clrRed, float clrGreen, float clrBlue, float clrAlpha) 
	{
	glClearColor(clrRed, clrGreen, clrBlue, clrAlpha);
	}

// glClear - clears buffers
void CWaiteGLCtrl::Clear(long bitMask) 
	{
	::glClear((UINT)bitMask);
	}


void CWaiteGLCtrl::Color(short clrRed, short clrGreen, short clrBlue, short clrAlpha) 
	{
	glColor4ub((BYTE)clrRed, (BYTE)clrGreen, (BYTE)clrBlue, (BYTE)clrAlpha);
	}


void CWaiteGLCtrl::Rect(float x1, float y1, float x2, float y2) 
	{
	glRectf(x1,y1,x2,y2);
	}


void CWaiteGLCtrl::Ortho(float leftSide, float rightSide, float bottomSide, float topSide, float nearSide, float farSide) 
	{
	glOrtho(leftSide, rightSide, bottomSide, topSide, nearSide, farSide);
	}


void CWaiteGLCtrl::Rotate(float Angle, float x, float y, float z) 
	{
	::glRotatef(Angle,x,y,z);
	}


// glLoadIdentity
void CWaiteGLCtrl::LoadIdentity() 
	{
	::glLoadIdentity();
	}

// glViewport
void CWaiteGLCtrl::Viewport(long x, long y, long width, long height) 
	{
	::glViewport(x, y, width, height);
	}

void CWaiteGLCtrl::Begin(long mode) 
	{
	glBegin(mode);
	}

void CWaiteGLCtrl::End() 
	{
	glEnd();
	}

void CWaiteGLCtrl::Enable(long cap) 
	{
	glEnable(cap);
	}

void CWaiteGLCtrl::Disable(long cap) 
	{
	glDisable(cap);	
	}

void CWaiteGLCtrl::Normal(float v1, float v2, float v3) 
	{
	glNormal3f(v1, v2, v3);
	}

void CWaiteGLCtrl::EndList() 
	{
	glEndList();
	}

void CWaiteGLCtrl::CallList(long listID) 
	{
	glCallList(listID);
	}

void CWaiteGLCtrl::NewList(long ListID, long ListType) 
	{
	glNewList(ListID, ListType);
	}

void CWaiteGLCtrl::DeleteLists(long start, long range) 
	{
	::glDeleteLists(start, range);
	}


void CWaiteGLCtrl::FrontFace(long face) 
	{
	::glFrontFace(face);
	}

// Added because begin is a reserved word in Delphi
void CWaiteGLCtrl::Start(long mode) 
{
	::glBegin(mode);
}

// Added becuse End is a reserved word in Delphi
void CWaiteGLCtrl::Stop() 
{
	::glEnd();
}


void CWaiteGLCtrl::PushMatrix() 
{
	::glPushMatrix();
}

void CWaiteGLCtrl::PopMatrix() 
{
	::glPopMatrix();
}


void CWaiteGLCtrl::Translate(float x, float y, float z) 
{
	::glTranslatef(x,y,z);
}

void CWaiteGLCtrl::Scale(float x, float y, float z) 
{
	::glScalef(x,y,z);
}


BOOL CWaiteGLCtrl::IsList(long ListID) 
{
	return ::glIsList(ListID);
}

void CWaiteGLCtrl::ListBase(long base) 
{
	::glListBase(base);
}


void CWaiteGLCtrl::LineStipple(long factor, short pattern) 
	{
	::glLineStipple(factor,pattern);
	}

void CWaiteGLCtrl::LineWidth(float width) 
	{
	::glLineWidth(width);
	}

void CWaiteGLCtrl::PointSize(float fSize) 
	{
	::glPointSize(fSize);
	}

void CWaiteGLCtrl::Vertex2(float x, float y) 
	{
	::glVertex2f(x,y);
	}

void CWaiteGLCtrl::Vertex3(float x, float y, float z) 
	{
	::glVertex3f(x,y,z);
	}

void CWaiteGLCtrl::Vertex4(float x, float y, float z, float w) 
	{
	::glVertex4f(x,y,z,w);
	}

void CWaiteGLCtrl::Hint(long target, long mode) 
	{
	::glHint(target, mode);
	}

void CWaiteGLCtrl::ShadeModel(long mode) 
	{
	::glShadeModel(mode);
	}

void CWaiteGLCtrl::CullFace(long mode) 
	{
	::glCullFace(mode);
	}


void CWaiteGLCtrl::Frustum(float left, float right, float bottom, float top, float nearz, float farz) 
	{
	glFrustum(left, right, bottom, top, nearz, farz);
	}

void CWaiteGLCtrl::PolygonMode(long face, long mode) 
	{
	::glPolygonMode(face, mode);
	}

void CWaiteGLCtrl::EdgeFlag(BOOL flag) 
	{
	::glEdgeFlag(flag);
	}


BSTR CWaiteGLCtrl::GetString(long name) 
	{
	CString strResult;
	const unsigned char *szString;

	szString = ::glGetString(name);

	if(szString == NULL)
		{
		strResult = "";
		return strResult.AllocSysString();
		}

	strResult = szString;

	return strResult.AllocSysString();
	}


long CWaiteGLCtrl::GetError() 
	{
	return ::glGetError();
	}


void CWaiteGLCtrl::ColorMaterial(long face, long mode) 
	{
	::glColorMaterial(face, mode);
	}



long CWaiteGLCtrl::RenderMode(long mode) 
{
	return ::glRenderMode(mode);
}

void CWaiteGLCtrl::InitNames() 
{
	glInitNames();
}

void CWaiteGLCtrl::PopName() 
{
	glPopName();
}


void CWaiteGLCtrl::PassThrough(float token) 
{
	::glPassThrough(token);
}

void CWaiteGLCtrl::AlphaFunc(long func, float ref) 
{
	::glAlphaFunc(func, ref);
}

void CWaiteGLCtrl::BlendFunc(long sfactor, long dfactor) 
{
	::glBlendFunc(sfactor, dfactor);
}

void CWaiteGLCtrl::PushName(long name) 
{
	::glPushName(name);
}

void CWaiteGLCtrl::LoadName(long name) 
{
	::glLoadName(name);
}


void CWaiteGLCtrl::MatrixMode(long mode) 
{
	::glMatrixMode(mode);
}

void CWaiteGLCtrl::LightModelv(long pname, float p0, float p1, float p2, float p3) 
	{
	GLfloat params[4];

	params[0] = p0;
	params[1] = p1;
	params[2] = p2;
	params[3] = p3;

	::glLightModelfv(pname, params);
	}

void CWaiteGLCtrl::Light(long light, long pname, float param) 
	{
	::glLightf(light, pname, param);

	}

void CWaiteGLCtrl::Lightf(long light, long pname, float p0, float p1, float p2, float p3) 
	{
	GLfloat params[4];

	params[0] = p0;
	params[1] = p1;
	params[2] = p2;
	params[3] = p3;

	::glLightfv(light, pname, params);
	}

void CWaiteGLCtrl::LightModel(long pname, float param) 
	{
	::glLightModelf(pname, param);
	}

void CWaiteGLCtrl::Material(long face, long pname, float param) 
	{
	::glMaterialf(face, pname, param);
	}

void CWaiteGLCtrl::Materialv(long face, long pname, float p0, float p1, float p2, float p3) 
	{
	GLfloat params[4];

	params[0] = p0;
	params[1] = p1;
	params[2] = p2;
	params[3] = p3;

	::glMaterialfv(face, pname, params);
	}

void CWaiteGLCtrl::GetMaterial(long face, long name, float FAR* p0, float FAR* p1, float FAR* p2, float FAR* p3) 
	{
	GLfloat params[4];

	params[0] = *p0;
	params[1] = *p1;
	params[2] = *p2;
	params[3] = *p3;

	::glGetMaterialfv(face, name, params);

	*p0 = params[0];	
	*p1 = params[1];
	*p2 = params[2];
	*p3 = params[3];
	}

void CWaiteGLCtrl::GetLight(long light, long pname, float FAR* p0, float FAR* p1, float FAR* p2, float FAR* p3) 
	{
	GLfloat params[4];

	params[0] = *p0;
	params[1] = *p1;
	params[2] = *p2;
	params[3] = *p3;

	::glGetLightfv(light, pname, params);

	*p0 = params[0];	
	*p1 = params[1];
	*p2 = params[2];
	*p3 = params[3];
	}

long CWaiteGLCtrl::GenLists(long range) 
	{
	return ::glGenLists(range);
	}


void CWaiteGLCtrl::ColorMask(BOOL bRed, BOOL bGreen, BOOL bBlue, BOOL bAlpha) 
	{
	::glColorMask(bRed, bGreen, bBlue, bAlpha);
	}

void CWaiteGLCtrl::Fogv(long pName, float p0, float p1, float p2, float p3) 
	{
	GLfloat params[4];
	
	params[0] = p0;
	params[1] = p1;
	params[2] = p2;
	params[3] = p3;

	::glFogfv(pName, params);
	}

void CWaiteGLCtrl::Fog(long pName, float param) 
	{
	::glFogf(pName, param);
	}


void CWaiteGLCtrl::GLBEGIN(long primtype) 
{
	::glBegin(primtype);
}

void CWaiteGLCtrl::GLEND() 
{
	::glEnd();
}


void CWaiteGLCtrl::CopyPixels(long x, long y, long w, long h, long typ) 
{
	::glCopyPixels(x, y, w, h, typ);
}

void CWaiteGLCtrl::RasterPos2(float x, float y) 
{
	::glRasterPos2f(x, y);
}

void CWaiteGLCtrl::RasterPos3(float x, float y, float z) 
{
	::glRasterPos3f(x, y, z);
}

void CWaiteGLCtrl::RasterPos4(float x, float y, float z, float w) 
{
	::glRasterPos4f(x, y, z, w);
}

void CWaiteGLCtrl::PixelStore(long name, float param) 
{
	::glPixelStoref(name, param);
}


void CWaiteGLCtrl::PixelZoom(float xFactor, float yFactor) 
{
	::glPixelZoom(xFactor, yFactor);
}


void CWaiteGLCtrl::PixelTransfer(long pName, float Param) 
{
	::glPixelTransferf(pName, Param);
}


BOOL CWaiteGLCtrl::IsEnabled(long lValue) 
{
	return ::glIsEnabled(lValue);
}

void CWaiteGLCtrl::GetFloatv(long lEnum, float FAR* pParams) 
{
	::glGetFloatv(lEnum, pParams);
}

void CWaiteGLCtrl::GetBooleanv(long lEnum, BOOL FAR* pData) 
{
	::glGetBooleanv(lEnum, (unsigned char *)pData);
}

void CWaiteGLCtrl::GetDoublev(long lEnum, double FAR* pData) 
{
	::glGetDoublev(lEnum, pData);
}

void CWaiteGLCtrl::GetInteger(long lEnum, long FAR* pData) 
{
	::glGetIntegerv(lEnum, (int *)pData);
}

void CWaiteGLCtrl::PushAttrib(long lMask) 
{
	::glPushAttrib(lMask);
}

void CWaiteGLCtrl::PopAttrib() 
{
	::glPopAttrib();
}

void CWaiteGLCtrl::Accum(long lOperand, float fValue) 
{
	::glAccum(lOperand, fValue);
}

void CWaiteGLCtrl::ClearStencil(long sValue) 
{
	::glClearStencil(sValue);
}

void CWaiteGLCtrl::ClearDepth(double dValue) 
{
	::glClearDepth(dValue);
}

void CWaiteGLCtrl::StencilMask(long lMask) 
{
	::glStencilMask(lMask);
}

void CWaiteGLCtrl::ClearAccum(float fRed, float fGreen, float fBlue, float fAlpha) 
{
	::glClearAccum(fRed, fGreen, fBlue, fAlpha);
}

void CWaiteGLCtrl::StencilFunc(long lFunc, long lRef, long lMask) 
{
	::glStencilFunc(lFunc, lRef, lMask);
}

void CWaiteGLCtrl::DepthFunc(long lFunc) 
{
	::glDepthFunc(lFunc);
}

void CWaiteGLCtrl::DepthRange(double dNear, double dFar) 
{
	::glDepthRange(dNear, dFar);
}

void CWaiteGLCtrl::ReadBuffer(long lMode) 
{
	::glReadBuffer(lMode);
}

void CWaiteGLCtrl::ClipPlane(long lPlane, double dA, double dB, double dC, double dD) 
	{
	GLdouble params[4];

	params[0] = dA;
	params[1] = dB;
	params[2] = dC;
	params[3] = dD;
	::glClipPlane(lPlane, params);
	}

void CWaiteGLCtrl::Scissor(long x, long y, long lWidth, long lHeight) 
{
	::glScissor(x, y, lWidth, lHeight);
}

void CWaiteGLCtrl::StencilOp(long fail, long zfail, long zpass) 
{
	::glStencilOp(fail, zfail, zpass);
}

void CWaiteGLCtrl::DrawBuffer(long lMode) 
{
	::glDrawBuffer(lMode);
}

void CWaiteGLCtrl::DepthMask(BOOL bMask) 
{
	::glDepthMask(bMask);
}

void CWaiteGLCtrl::GetClipPlane(long lPlane, double FAR* dpa, double FAR* dpb, double FAR* dpc, double FAR* dpd) 
	{
	GLdouble params[4];

	::glGetClipPlane(lPlane, params);
	*dpa = params[0];
	*dpb = params[1];
	*dpc = params[2];
	*dpd = params[3];
	}


void CWaiteGLCtrl::GetMap(long lTarget, long lQuery, float FAR* pfValues) 
{
	glGetMapfv(lTarget, lQuery, pfValues);
}

void CWaiteGLCtrl::EvalCoord1(float fU) 
{
	::glEvalCoord1f(fU);
}

void CWaiteGLCtrl::EvalCoord2(float fU, float fV) 
{
	::glEvalCoord2f(fU, fV);
}

void CWaiteGLCtrl::EvalMesh1(long lMode, long l1, long l2) 
{
	::glEvalMesh1(lMode, l1, l2);
}

void CWaiteGLCtrl::EvalMesh2(long lMode, long l1, long l2, long l3, long l4) 
{
	::glEvalMesh2(lMode, l1, l2, l3, l4);
}

void CWaiteGLCtrl::EvalPoint1(long i) 
{
	::glEvalPoint1(i);
}

void CWaiteGLCtrl::EvalPoint2(long i, long j) 
{
	::glEvalPoint2(i, j);
}

void CWaiteGLCtrl::Map1(long lTarget, float u1, float u2, long iStride, long iOrder, float FAR* pPoints) 
{
	::glMap1f(lTarget, u1, u2, iStride, iOrder, pPoints);
}

void CWaiteGLCtrl::Map2(long lTarget, float u1, float u2, long uStride, long uOrder, float v1, float v2, long ivstride, long ivorder, float FAR* pData) 
{
	::glMap2f(lTarget, u1, u2, uStride, uOrder, v1, v2, ivstride, ivorder, pData);
}

void CWaiteGLCtrl::MapGrid1(long un, float v1, float v2) 
	{
	::glMapGrid1f(un, v1, v2);
	}	

void CWaiteGLCtrl::MapGrid2(long un, float u1, float u2, long vn, float v1, float v2) 
	{
	::glMapGrid2f(un, u1, u2, vn, v1, v2);
	}




void CWaiteGLCtrl::GetTexEnvfv(long lTarget, long lPname, float FAR* pParams) 
{
	::glGetTexEnvfv(lTarget, lPname, pParams);
}

void CWaiteGLCtrl::GetTexGenfv(long lCoord, long lPName, float FAR* pParams) 
{
	::glGetTexGenfv(lCoord, lPName, pParams);
}

void CWaiteGLCtrl::GetTexLevelParameterfv(long lTarget, long lLevel, long lPname, float FAR* pParams) 
{
	::glGetTexLevelParameterfv(lTarget, lLevel, lPname, pParams);
}

void CWaiteGLCtrl::GetTexParameterfv(long lTarget, long lPname, float FAR* pParams) 
{
	::glTexParameterfv(lTarget, lPname, pParams);
}

void CWaiteGLCtrl::TexCoord1f(float fS) 
{
	::glTexCoord1f(fS);
}

void CWaiteGLCtrl::TexCoord2f(float fS, float fT) 
{
	::glTexCoord2f(fS, fT);
}

void CWaiteGLCtrl::TexCoord3f(float fS, float fT, float fR) 
{
	::glTexCoord3f(fS, fT, fR);
}

void CWaiteGLCtrl::TexCoord4f(float fS, float fT, float fR, float fQ) 
{
	::glTexCoord4f(fS, fT, fR, fQ);
}

void CWaiteGLCtrl::TexEnvf(long lTarget, long lPName, float fParam) 
{
	::glTexEnvf(lTarget, lPName, fParam);
}

void CWaiteGLCtrl::TexEnvfv(long lTarget, long lPname, float FAR* pParams) 
{
	::glTexEnvfv(lTarget, lPname, pParams);
}

void CWaiteGLCtrl::TexGenf(long lCoord, long lName, float fParam) 
{
	::glTexGenf(lCoord, lName, fParam);
}

void CWaiteGLCtrl::TexGenfv(long lCoord, long lPname, float FAR* pfParams) 
{
	::glTexGenfv(lCoord, lPname, pfParams);
}

void CWaiteGLCtrl::TexParameterf(long lTarget, long lPname, float fParam) 
{
	::glTexParameterf(lTarget, lPname, fParam);
}

void CWaiteGLCtrl::TexParameterfv(long lTarget, long lPname, float FAR* pfParams) 
{
	::glTexParameterfv(lTarget, lPname, pfParams);
}

void CWaiteGLCtrl::TexImage1D(long lTarget, long lLevel, long lComponent, long lWidth, long lBorder,
								long lFormat, long lType, VARIANT FAR* pPixels) 
{
	::glTexImage1D(lTarget, lLevel, lComponent, lWidth, lBorder, lFormat, lType, pPixels);
}

void CWaiteGLCtrl::TexImage2D(long lTarget, long lLevel, long lComponent, long lWidth, 
				long lHeight, long lBorder, long lFormat, long lType, VARIANT FAR* pPixels) 
{
	::glTexImage2D(lTarget, lLevel, lComponent, lWidth, lHeight, lBorder, lFormat, lType, pPixels);
}

void CWaiteGLCtrl::PolygonStipple(VARIANT FAR* pMask) 
	{
	::glPolygonStipple((const unsigned char *)pMask);
	}


void CWaiteGLCtrl::GetPolygonStipple(VARIANT FAR* pMask) 
	{
	::glGetPolygonStipple((unsigned char *)pMask);
	}


void CWaiteGLCtrl::LoadMatrix(float FAR* matrix) 
	{
	::glLoadMatrixf(matrix);
	}

void CWaiteGLCtrl::MultMatrix(float FAR* matrix) 
	{
	::glMultMatrixf(matrix);
	}


void CWaiteGLCtrl::DrawPixels(long w, long h, long format, long ptype, VARIANT FAR* pixels) 
{
	::glDrawPixels(w, h, format, ptype, pixels);
}

void CWaiteGLCtrl::ReadPixels(long x, long y, long w, long h, long pformat, long ptype, VARIANT FAR* pPixels) 
{
	::glReadPixels(x, y, w, h, pformat, ptype, pPixels);
}

void CWaiteGLCtrl::Bitmap(long width, long height, float xorg, float yorg, float xmove, float ymove, VARIANT FAR* pBitmap) 
	{
	::glBitmap(width, height, xorg, yorg, xmove, ymove, (const unsigned char *)pBitmap);
	}

void CWaiteGLCtrl::CallLists(long listSize, long listType, VARIANT FAR* listData) 
{
	::glCallLists(listSize, listType, listData);
}


void CWaiteGLCtrl::GetPixelMap(long map, VARIANT FAR* pValues) 
{
	::glGetPixelMapfv(map, (float *)pValues);
}

void CWaiteGLCtrl::gluBuild2dMipmaps(long target, long comp, long width, long height, long format, long gtype, VARIANT FAR* pData) 
{
	::gluBuild2DMipmaps(target, comp, width, height, format, gtype, pData);
}

void CWaiteGLCtrl::gluBuild1DMipmaps(long target, long comp, long width, long format, long gtype, VARIANT FAR* pData) 
	{
	::gluBuild1DMipmaps(target, comp, width, format, gtype, pData);
	}


void CWaiteGLCtrl::PixelMap(long map, long mapSize, VARIANT FAR* values) 
{
	::glPixelMapfv(map, mapSize, (const float *)values);
}


void CWaiteGLCtrl::SelectBuffer(long size, VARIANT FAR* pBuffer) 
{
	::glSelectBuffer(size, (unsigned int *)pBuffer);
}

void CWaiteGLCtrl::FeedbackBuffer(long size, long buffType, VARIANT FAR* pBuffer) 
{
	::glFeedbackBuffer(size, buffType, (float *)pBuffer);
}

