// ocxglu.cpp
// OCX Wrappers for glu library

#include "stdafx.h"
#include "WaiteGL.h"
#include "WaiteGLCtl.h"
#include "WaiteGLPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//////////////////////////////////////////////
// FUNCTIONS

// gluPerspective
void CWaiteGLCtrl::gluPerspective(double fovy, double aspect, double zNear, double zFar) 
	{
	::gluPerspective(fovy, aspect, zNear, zFar);
	}


void CWaiteGLCtrl::gluLookAt(float eyex, float eyey, float eyez, float centerx, float centery, float centerz, float upx, float upy, float upz) 
	{
	::gluLookAt(eyex, eyey, eyez, centerx, centery, centerz, upx, upy, upz);
	}

void CWaiteGLCtrl::gluOrtho2D(float left, float right, float bottom, float top) 
	{
	::gluOrtho2D(left, right, bottom, top);
	}


BSTR CWaiteGLCtrl::gluErrorString(long errCode) 
	{
	CString strResult;
	const unsigned char *szString;

	szString = ::gluErrorString(errCode);

	if(szString == NULL)
		{
		strResult = "";
		return strResult.AllocSysString();
		}

	strResult = szString;

	return strResult.AllocSysString();
	}



BSTR CWaiteGLCtrl::gluGetString(long name) 
	{
	CString strResult;
	const unsigned char *szString;

	szString = ::gluGetString(name);

	// Check for errors first
	if(szString == NULL)
		{
		strResult = "";
		return strResult.AllocSysString();
		}

	strResult = szString;

	return strResult.AllocSysString();
	}




long CWaiteGLCtrl::gluNewQuadric() 
	{
	return (long)::gluNewQuadric();
	}

void CWaiteGLCtrl::gluDeleteQuadric(long lQuadric) 
	{
	::gluDeleteQuadric((GLUquadricObj*)lQuadric);
	}

void CWaiteGLCtrl::gluQuadricNormals(long lObject, long lNormals) 
{
	::gluQuadricNormals((GLUquadricObj*)lObject, lNormals);
}

void CWaiteGLCtrl::gluQuadricOrientation(long lObject, long lOrientation) 
{
	::gluQuadricOrientation((GLUquadricObj*)lObject, lOrientation);
}

void CWaiteGLCtrl::gluQuadricDrawStyle(long lObject, long lStyle) 
{
	::gluQuadricDrawStyle((GLUquadricObj*)lObject, lStyle);
}

void CWaiteGLCtrl::gluCylinder(long lObject, double baseRadius, double topRadius, double heightVal, long iSlices, long iStacks) 
{
	::gluCylinder((GLUquadricObj*)lObject, baseRadius, topRadius, heightVal, iSlices, iStacks);
}

void CWaiteGLCtrl::gluPartialDisk(long lObject, double innerRadius, double outerRadius, long iSlices, long iLoops, double startAngle, double sweepAngle) 
{
	::gluPartialDisk((GLUquadricObj*)lObject, innerRadius, outerRadius, iSlices, iLoops, startAngle, sweepAngle);
}

void CWaiteGLCtrl::gluDisk(long lObject, double innerRadius, double outerRadius, long iSlices, long iLoops) 
{
	::gluDisk((GLUquadricObj*)lObject, innerRadius, outerRadius, iSlices, iLoops);
}

void CWaiteGLCtrl::gluSphere(long lObject, double dRadius, long iSlices, long iStacks) 
{
	::gluSphere((GLUquadricObj*)lObject, dRadius, iSlices, iStacks);
}

void CWaiteGLCtrl::gluQuadricTexture(long lObject, BOOL bCoords) 
{
	::gluQuadricTexture((GLUquadricObj*)lObject, bCoords);
}

void CWaiteGLCtrl::gluBeginPolygon(long lTesselator) 
	{
	::gluBeginPolygon((GLUtesselator *) lTesselator);
	}

void CWaiteGLCtrl::gluEndPolygon(long lTesselator) 
	{
	::gluEndPolygon((GLUtesselator *)lTesselator);
	}

long CWaiteGLCtrl::gluNewTess() 
	{
	return (long)::gluNewTess();
	}

void CWaiteGLCtrl::gluDeleteTess(long lTesselator) 
	{
	::gluDeleteTess((GLUtesselator *)lTesselator);
	}

void CWaiteGLCtrl::gluNextCountour(long lTesselator, long lType) 
{
	::gluNextContour((GLUtesselator *)lTesselator, lType);
}

void CWaiteGLCtrl::gluTessNormal(long lTesselator, double x, double y, double z) 
{
	::gluTessNormal((GLUtesselator *)lTesselator, x, y, z);
}

void CWaiteGLCtrl::gluTessProperty(long lTesselator, long lWhich, double dValue) 
{
	::gluTessProperty((GLUtesselator *)lTesselator, lWhich, dValue);
}

void CWaiteGLCtrl::gluGetTessProperty(long lTesselator, long lWhich, double FAR* dValue) 
{
	::gluGetTessProperty((GLUtesselator *)lTesselator, lWhich, dValue);
}

void CWaiteGLCtrl::gluTessBeginPolygon(long lTesselator, VARIANT FAR* pData) 
{
	::gluTessBeginPolygon((GLUtesselator *)lTesselator, pData);
}

void CWaiteGLCtrl::gluTessEndPolygon(long lTesselator) 
{
	::gluTessEndPolygon((GLUtesselator *)lTesselator);
}

void CWaiteGLCtrl::gluTessBeginContour(long lTesselator) 
{
	::gluTessBeginContour((GLUtesselator *)lTesselator);
}


void CWaiteGLCtrl::gluTessEndContour(long lTesselator) 
{
	::gluTessEndContour((GLUtesselator *)lTesselator);
}

long CWaiteGLCtrl::gluNewNurbsRenderer() 
{
	return (long)::gluNewNurbsRenderer();
}

void CWaiteGLCtrl::gluDeleteNurbsRenderer(long lNurbObj) 
{
	::gluDeleteNurbsRenderer((GLUnurbsObj*)lNurbObj);
}

void CWaiteGLCtrl::gluBeginSurface(long lObj) 
{
	::gluBeginSurface((GLUnurbsObj*)lObj);
}

void CWaiteGLCtrl::gluEndCurve(long lObj) 
{
	::gluEndCurve((GLUnurbsObj*)lObj);
}

void CWaiteGLCtrl::gluBeginTrim(long lObj) 
{
	::gluBeginTrim((GLUnurbsObj*)lObj);
}

void CWaiteGLCtrl::gluBeginCurve(long lObj) 
{
	::gluBeginCurve((GLUnurbsObj*)lObj);
}

void CWaiteGLCtrl::gluEndSurface(long lObj) 
{
	::gluEndSurface((GLUnurbsObj*)lObj);
}

void CWaiteGLCtrl::gluEndTrim(long lObj) 
{
	::gluEndTrim((GLUnurbsObj*)lObj);
}


void CWaiteGLCtrl::gluPwlCurve(long lObj, long lCount, float FAR* pPoints, long lStride, long lType) 
{
	::gluPwlCurve((GLUnurbsObj*)lObj, lCount, pPoints, lStride, lType);
}

void CWaiteGLCtrl::gluNurbsCurve(long lObj, long lKnots, float FAR* pKnots, long lStride, float FAR* pControl, long lOrder, long lType) 
{
	::gluNurbsCurve((GLUnurbsObj*)lObj, lKnots, pKnots, lStride, pControl, lOrder, lType);
}

void CWaiteGLCtrl::gluNurbsSurface(long lObj, long sKnot, float FAR* psKnots, long tKnot, float FAR* ptKnots, long sStride, long tStride, float FAR* pCtlPoints, long sOrder, long tOrder, long lType) 
{
	::gluNurbsSurface((GLUnurbsObj*)lObj, sKnot, psKnots, tKnot, ptKnots, sStride, tStride, pCtlPoints, sOrder, tOrder, lType);
}

void CWaiteGLCtrl::gluNurbsProperty(long lObj, long lProperty, float fValue) 
{
	::gluNurbsProperty((GLUnurbsObj*)lObj, lProperty, fValue);
}

void CWaiteGLCtrl::gluGetNurbsProperty(long lObj, long lProperty, float FAR* pfValue) 
{
	::gluGetNurbsProperty((GLUnurbsObj*)lObj, lProperty, pfValue);
}


void CWaiteGLCtrl::gluPickMatrix(double x, double y, double width, double height, VARIANT FAR* viewport) 
{
	::gluPickMatrix(x, y, width, height, (int *)viewport);
}

void CWaiteGLCtrl::gluScaleImage(long format, long widthin, long heightin, long typein, VARIANT FAR* datain, long widthout, long heightout, long typeout, VARIANT FAR* dataout) 
{
	::gluScaleImage(format, widthin, heightin,typein,(void *)datain,widthout, heightout, typeout, (void *)dataout);
}
