// WaiteGLCtl.h : Declaration of the CWaiteGLCtrl OLE control class.

/////////////////////////////////////////////////////////////////////////////
// CWaiteGLCtrl : See WaiteGLCtl.cpp for implementation.

class CWaiteGLCtrl : public COleControl
{
	DECLARE_DYNCREATE(CWaiteGLCtrl)

// Constructor
public:
	CWaiteGLCtrl();

// Overrides

	// Drawing function
	virtual void OnDraw(
				CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);

	// Persistence
	virtual void DoPropExchange(CPropExchange* pPX);

	// Reset control state
	virtual void OnResetState();


protected:
	HDC		m_hDC;				// Device Context
	HGLRC   m_hRC;				// Rendering context
	BOOL	m_bSetupRC;			// Flag to fire setup once
	CPalette	m_GLPalette;	// 3-3-2 palette
// Implementation
protected:
	~CWaiteGLCtrl();

	void InitializePalette(void);

	DECLARE_OLECREATE_EX(CWaiteGLCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CWaiteGLCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CWaiteGLCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CWaiteGLCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CWaiteGLCtrl)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg BOOL OnQueryNewPalette();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CWaiteGLCtrl)
	afx_msg void Flush();
	afx_msg void ClearColor(float clrRed, float clrGreen, float clrBlue, float clrAlpha);
	afx_msg void Clear(long bitMask);
	afx_msg long glColorBufferBit();
	afx_msg BOOL SwapBuffers();
	afx_msg BOOL MakeCurrent();
	afx_msg BOOL MakeNotCurrent();
	afx_msg void Color(short clrRed, short clrGreen, short clrBlue, short clrAlpha);
	afx_msg void Rect(float x1, float y1, float x2, float y2);
	afx_msg void Ortho(float leftSide, float rightSide, float bottomSide, float topSide, float nearSide, float farSide);
	afx_msg void auxSolidTeapot(double Size);
	afx_msg void auxWireTeapot(double Size);
	afx_msg void Rotate(float Angle, float x, float y, float z);
	afx_msg void LoadIdentity();
	afx_msg void gluPerspective(double fovy, double aspect, double zNear, double zFar);
	afx_msg long glAccum();
	afx_msg void auxSolidSphere(double radius);
	afx_msg void auxWireSphere(double radius);
	afx_msg void auxWireCube(double size);
	afx_msg void auxSolidCube(double size);
	afx_msg void auxWireBox(double width, double height, double depth);
	afx_msg void auxSolidBox(double width, double height, double depth);
	afx_msg void auxSolidTorus(double innerRadius, double outerRadius);
	afx_msg void auxWireTorus(double innerRadius, double outerRadius);
	afx_msg void auxWireCylinder(double radius, double height);
	afx_msg void auxSolidCylinder(double radius, double height);
	afx_msg void auxWireIcosahedron(double radius);
	afx_msg void auxSolidIcosahedron(double radius);
	afx_msg void auxWireOctahedron(double radius);
	afx_msg void auxSolidOctahedron(double radius);
	afx_msg void auxWireDodecahedron(double radius);
	afx_msg void auxSolidDodecahedron(double radius);
	afx_msg void auxWireCone(double radius, double height);
	afx_msg void auxSolidCone(double radius, double height);
	afx_msg void Viewport(long x, long y, long width, long height);
	afx_msg long wglGetRC();
	afx_msg long wglGetDC();
	afx_msg BOOL wglUseFontBitmaps(long hdc, long first, long count, long listbase);
	afx_msg void Begin(long mode);
	afx_msg void End();
	afx_msg void Enable(long cap);
	afx_msg void Disable(long cap);
	afx_msg long glLoad();
	afx_msg long glReturn();
	afx_msg long glMult();
	afx_msg long glAdd();
	afx_msg long glNever();
	afx_msg long glLess();
	afx_msg long glEqual();
	afx_msg long glLequal();
	afx_msg long glGreater();
	afx_msg long glNotequal();
	afx_msg long glGequal();
	afx_msg long glAlways();
	afx_msg long glPoints();
	afx_msg long glLines();
	afx_msg long glLineLoop();
	afx_msg long glLineStrip();
	afx_msg long glTriangles();
	afx_msg long glTriangleStrip();
	afx_msg long glTriangleFan();
	afx_msg long glQuads();
	afx_msg long glQuadStrip();
	afx_msg long glPolygon();
	afx_msg void Normal(float v1, float v2, float v3);
	afx_msg long glCurrentBit();
	afx_msg long glPointbit();
	afx_msg long glLineBit();
	afx_msg long glPolygonBit();
	afx_msg long glPolygonStippleBit();
	afx_msg long glPixelModeBit();
	afx_msg long glLightingBit();
	afx_msg long glFogBit();
	afx_msg long glDepthBufferBit();
	afx_msg long glAccumBufferBit();
	afx_msg long glStencilBufferbit();
	afx_msg long glViewportBit();
	afx_msg long glTransformBit();
	afx_msg long glEnableBit();
	afx_msg long glHintBit();
	afx_msg long glEvalBit();
	afx_msg long glListBit();
	afx_msg long glTextureBit();
	afx_msg long glScissorBit();
	afx_msg long glAllAttribBits();
	afx_msg long glNoError();
	afx_msg long glInvalidEnum();
	afx_msg long glInvalidValue();
	afx_msg long glInvalidOperation();
	afx_msg long glStackOverflow();
	afx_msg long glStackUnderflow();
	afx_msg long glOutOfMemory();
	afx_msg long glDontCare();
	afx_msg long glFastest();
	afx_msg long glNicest();
	afx_msg long glLight0();
	afx_msg long glLight1();
	afx_msg long glLight2();
	afx_msg long glLight3();
	afx_msg long glLight4();
	afx_msg long glLight5();
	afx_msg long glLight6();
	afx_msg long glLight7();
	afx_msg long glAmbient();
	afx_msg long glDiffuse();
	afx_msg long glSpecular();
	afx_msg long glPosition();
	afx_msg long glSpotDirection();
	afx_msg long glSpotExponent();
	afx_msg long glSpotCutoff();
	afx_msg long glConstantAttenuation();
	afx_msg long glLinearAttenuation();
	afx_msg long glQuadraticAttenuation();
	afx_msg long glEmission();
	afx_msg long glShininess();
	afx_msg long glAmbientAndDiffuse();
	afx_msg long glColorIndexes();
	afx_msg long glModelview();
	afx_msg long glProjection();
	afx_msg long glTexture();
	afx_msg void EndList();
	afx_msg void CallList(long listID);
	afx_msg void NewList(long ListID, long ListType);
	afx_msg void DeleteLists(long start, long range);
	afx_msg long glColor();
	afx_msg long glDepth();
	afx_msg long glStencil();
	afx_msg long glFlat();
	afx_msg long glSmooth();
	afx_msg long glPoint();
	afx_msg long glLine();
	afx_msg long glFill();
	afx_msg long glCw();
	afx_msg long glCcw();
	afx_msg long glCurrentColor();
	afx_msg long glCurrentIndex();
	afx_msg long glCurrentNormal();
	afx_msg long glCurrentTextureCoords();
	afx_msg long glCurrentRasterColor();
	afx_msg long glCurrentRasterIndex();
	afx_msg long glCurrentRasterTextureCoords();
	afx_msg long glCurrentRasterPosition();
	afx_msg long glCurrentRasterPositionValid();
	afx_msg long glCurrentRasterDistance();
	afx_msg long glPointSmooth();
	afx_msg long glPointSize();
	afx_msg long glPointSizeRange();
	afx_msg long glPointSizeGranularity();
	afx_msg long glLineSmooth();
	afx_msg long glLineWidth();
	afx_msg long glLineWidthRange();
	afx_msg long glLineWidthGranularity();
	afx_msg long glLineStipple();
	afx_msg long glLineStipplePattern();
	afx_msg long glLineStippleRepeat();
	afx_msg long glListMode();
	afx_msg long glMaxListNesting();
	afx_msg long glListBase();
	afx_msg long glListIndex();
	afx_msg long glPolygonMode();
	afx_msg long glPolygonSmooth();
	afx_msg long glPolygonStipple();
	afx_msg long glEdgeFlag();
	afx_msg long glCullFace();
	afx_msg long glCullFaceMode();
	afx_msg long glFrontFace();
	afx_msg long glLighting();
	afx_msg long glLightModelLocalViewer();
	afx_msg long glLightModelTwoSide();
	afx_msg long glLightModelAmbient();
	afx_msg long glShadeModel();
	afx_msg long glColorMaterialFace();
	afx_msg long glColorMaterialParameter();
	afx_msg long glColorMaterial();
	afx_msg long glFog();
	afx_msg long glFogIndex();
	afx_msg long glFogDensity();
	afx_msg long glFogStart();
	afx_msg long glFogEnd();
	afx_msg long glFogMode();
	afx_msg long glFogColor();
	afx_msg long glDepthRange();
	afx_msg long glDepthTest();
	afx_msg long glDepthWritemask();
	afx_msg long glDepthClearValue();
	afx_msg long glDepthFunc();
	afx_msg long glAccumClearValue();
	afx_msg long glStencilTest();
	afx_msg long glStencilClearValue();
	afx_msg long glStencilFunc();
	afx_msg long glStencilValueMask();
	afx_msg long glStencilFail();
	afx_msg long glStencilPassDepthFail();
	afx_msg long glStencilPassDepthPass();
	afx_msg long glStencilRef();
	afx_msg long glStencilWritemask();
	afx_msg long glMatrixMode();
	afx_msg long glNormalize();
	afx_msg long glViewport();
	afx_msg long glModelviewStackDepth();
	afx_msg long glProjectionStackDepth();
	afx_msg long glTextureStackDepth();
	afx_msg long glModelviewMatrix();
	afx_msg long glProjectionMatrix();
	afx_msg long glTextureMatrix();
	afx_msg long glAttribStackDepth();
	afx_msg long glCompile();
	afx_msg long glCompileAndExecute();
	afx_msg long glBitmap();
	afx_msg long glRender();
	afx_msg long glFeedback();
	afx_msg long glSelect();
	afx_msg long glVendor();
	afx_msg long glRenderer();
	afx_msg long glVersion();
	afx_msg long glExtensions();
	afx_msg long glAlphaTest();
	afx_msg long glAlphaTestFunc();
	afx_msg long glAlphaTestRef();
	afx_msg long glDither();
	afx_msg void FrontFace(long face);
	afx_msg void Start(long mode);
	afx_msg void Stop();
	afx_msg void PushMatrix();
	afx_msg void PopMatrix();
	afx_msg void Translate(float x, float y, float z);
	afx_msg void Scale(float x, float y, float z);
	afx_msg BOOL IsList(long ListID);
	afx_msg void ListBase(long base);
	afx_msg void LineStipple(long factor, short pattern);
	afx_msg void LineWidth(float width);
	afx_msg void PointSize(float fSize);
	afx_msg void Vertex2(float x, float y);
	afx_msg void Vertex3(float x, float y, float z);
	afx_msg void Vertex4(float x, float y, float z, float w);
	afx_msg long glClamp();
	afx_msg long glRepeat();
	afx_msg void PolygonStipple(VARIANT FAR* pMask);
	afx_msg void PolygonMode(long face, long mode);
	afx_msg void EdgeFlag(BOOL flag);
	afx_msg void GetPolygonStipple(VARIANT FAR* pMask);
	afx_msg void Frustum(float left, float right, float bottom, float top, float nearz, float farz);
	afx_msg void gluLookAt(float eyex, float eyey, float eyez, float centerx, float centery, float centerz, float upx, float upy, float upz);
	afx_msg void gluOrtho2D(float left, float right, float bottom, float top);
	afx_msg void Hint(long target, long mode);
	afx_msg void ShadeModel(long mode);
	afx_msg void CullFace(long mode);
	afx_msg long glNearest();
	afx_msg long glLinear();
	afx_msg long glTextureMagFilter();
	afx_msg long glTextureMinFilter();
	afx_msg long glTextureWrapS();
	afx_msg long glTextureWrapT();
	afx_msg long glNearestMipmapNearest();
	afx_msg long glLinearMipmapNearest();
	afx_msg long glNearestMipmapLinear();
	afx_msg long glLinearMipmapLinear();
	afx_msg BSTR gluErrorString(long errCode);
	afx_msg BSTR GetString(long name);
	afx_msg long GetError();
	afx_msg BSTR gluGetString(long name);
	afx_msg long glKeep();
	afx_msg long glReplace();
	afx_msg long glIncr();
	afx_msg long glDecr();
	afx_msg long glS();
	afx_msg long glT();
	afx_msg long glR();
	afx_msg long glQ();
	afx_msg long glModulate();
	afx_msg long glDecal();
	afx_msg long glTextureEnvMode();
	afx_msg long glTextureEnvColor();
	afx_msg long glTextureEnv();
	afx_msg long glEyeLinear();
	afx_msg long glObjectLinear();
	afx_msg long glSphereMap();
	afx_msg long glTextureGenMode();
	afx_msg long glObjectPlane();
	afx_msg long glEyePlane();
	afx_msg long gluVersion();
	afx_msg long gluExtensions();
	afx_msg long glZero();
	afx_msg long glOne();
	afx_msg long glSrcColor();
	afx_msg long glOneMinusSrcColor();
	afx_msg long glSrcAlpha();
	afx_msg long glOneMinusSrcAlpha();
	afx_msg long glDstAlpha();
	afx_msg long glOneMinusDstAlpha();
	afx_msg long glDstColor();
	afx_msg long glOneMinusDstColor();
	afx_msg long glSrcAlphaSaturate();
	afx_msg long glClipPlane0();
	afx_msg long glClipPlane1();
	afx_msg long glClipPlane2();
	afx_msg long glClipPlane3();
	afx_msg long glClipPlane4();
	afx_msg long glClipPlane5();
	afx_msg long glNone();
	afx_msg long glFrontLeft();
	afx_msg long glFrontRight();
	afx_msg long glBackLeft();
	afx_msg long glBackRight();
	afx_msg long glFront();
	afx_msg long glBack();
	afx_msg long glLeft();
	afx_msg long glRight();
	afx_msg long glFrontAndBack();
	afx_msg long glAux0();
	afx_msg long glAux1();
	afx_msg long glAux2();
	afx_msg long glAux3();
	afx_msg long gl2d();
	afx_msg long gl3d();
	afx_msg long gl3dColor();
	afx_msg long gl3dColorTexture();
	afx_msg long gl4dColorTexture();
	afx_msg long glPassThroughToken();
	afx_msg long glPointToken();
	afx_msg long glLineToken();
	afx_msg long glPolygonToken();
	afx_msg long glBitmapToken();
	afx_msg long glDrawPixelToken();
	afx_msg long glCopyPixelToken();
	afx_msg long glLineResetToken();
	afx_msg long glExp();
	afx_msg long glExp2();
	afx_msg long glCoeff();
	afx_msg long glOrder();
	afx_msg long glDomain();
	afx_msg long glBlendDst();
	afx_msg long glBlendSrc();
	afx_msg long glBlend();
	afx_msg long glLogicOpMode();
	afx_msg long glLogicOp();
	afx_msg long glAuxBuffers();
	afx_msg long glDrawBuffer();
	afx_msg long glReadBuffer();
	afx_msg long glScissorBox();
	afx_msg long glScissorTest();
	afx_msg long glIndexClearValue();
	afx_msg long glIndexWritemask();
	afx_msg long glColorClearValue();
	afx_msg long glColorWritemask();
	afx_msg long glIndexMode();
	afx_msg long glRgbaMode();
	afx_msg void ColorMaterial(long face, long mode);
	afx_msg long glStereo();
	afx_msg long glRenderMode();
	afx_msg long glPerspectiveCorrectionHint();
	afx_msg long glPointSmoothHint();
	afx_msg long glLineSmoothHint();
	afx_msg long glPolygonSmoothHint();
	afx_msg long glFogHint();
	afx_msg long glTextureGenS();
	afx_msg long glTextureGenT();
	afx_msg long glTextureGenR();
	afx_msg long glTextureGenQ();
	afx_msg long glPixelMapIToI();
	afx_msg long glPixelMapSToS();
	afx_msg long glPixelMapIToR();
	afx_msg long glPixelMapIToG();
	afx_msg long glPixelMapIToB();
	afx_msg long glPixelMapIToA();
	afx_msg long glPixelMapRToR();
	afx_msg long glPixelMapGToG();
	afx_msg long glPixelMapBToB();
	afx_msg long glPixelMapAToA();
	afx_msg long glPixelMapIToISize();
	afx_msg long glPixelMapSToSSize();
	afx_msg long glPixelMapIToRSize();
	afx_msg long glPixelMapIToGSize();
	afx_msg long glPixelMapIToBSize();
	afx_msg long glPixelMapIToASize();
	afx_msg long glPixelMapRToRSize();
	afx_msg long glPixelMapGToGSize();
	afx_msg long glPixelMapBToBSize();
	afx_msg long glPixelMapAToASize();
	afx_msg long glUnpackSwapBytes();
	afx_msg long glUnpackLsbFirst();
	afx_msg long glUnpackRowLength();
	afx_msg long glUnpackSkipRows();
	afx_msg long glUnpackSkipPixels();
	afx_msg long glUnpackAlignment();
	afx_msg long glPackSwapBytes();
	afx_msg long glPackLsbFirst();
	afx_msg long glPackRowLength();
	afx_msg long glPackSkipRows();
	afx_msg long glPackSkipPixels();
	afx_msg long glPackAlignment();
	afx_msg long glMapColor();
	afx_msg long glMapStencil();
	afx_msg long glIndexShift();
	afx_msg long glIndexOffset();
	afx_msg long glRedScale();
	afx_msg long glRedBias();
	afx_msg long glZoomX();
	afx_msg long glZoomY();
	afx_msg long glGreenScale();
	afx_msg long glGreenBias();
	afx_msg long glBlueScale();
	afx_msg long glBlueBias();
	afx_msg long glAlphaScale();
	afx_msg long glAlphaBias();
	afx_msg long glDepthScale();
	afx_msg long glDepthBias();
	afx_msg long glMaxEvalOrder();
	afx_msg long glMaxLights();
	afx_msg long glMaxClipPlanes();
	afx_msg long glMaxTextureSize();
	afx_msg long glMaxPixelMapTable();
	afx_msg long glMaxAttribStackDepth();
	afx_msg long glMaxModelviewStackDepth();
	afx_msg long glMaxNameStackDepth();
	afx_msg long glMaxProjectionStackDepth();
	afx_msg long glMaxTextureStackDepth();
	afx_msg long glMaxViewportDims();
	afx_msg long glSubpixelBits();
	afx_msg long glIndexBits();
	afx_msg long glRedBits();
	afx_msg long glGreenBits();
	afx_msg long glBlueBits();
	afx_msg long glAlphaBits();
	afx_msg long glDepthBits();
	afx_msg long glStencilBits();
	afx_msg long glAccumRedBits();
	afx_msg long glAccumGreenBits();
	afx_msg long glAccumAlphaBits();
	afx_msg long glNameStackDepth();
	afx_msg long glAutoNormal();
	afx_msg long glMap1Color4();
	afx_msg long glMap1Index();
	afx_msg long glMap1Normal();
	afx_msg long glMap1TextureCoord1();
	afx_msg long glMap1TextureCoord2();
	afx_msg long glMap1TextureCoord3();
	afx_msg long glMap1TextureCoord4();
	afx_msg long glMap1Vertex3();
	afx_msg long glMap1Vertex4();
	afx_msg long glMap2Color4();
	afx_msg long glMap2Index();
	afx_msg long glMap2Normal();
	afx_msg long glMap2TextureCoord1();
	afx_msg long glMap2TextureCoord2();
	afx_msg long glMap2TextureCoord3();
	afx_msg long glMap2TextureCoord4();
	afx_msg long glMap2Vertex3();
	afx_msg long glMap2Vertex4();
	afx_msg long glMap1GridDomain();
	afx_msg long glMap1GridSegments();
	afx_msg long glMap2GridDomain();
	afx_msg long glMap2GridSegments();
	afx_msg long glTexture1d();
	afx_msg long glTexture2d();
	afx_msg long glTextureWidth();
	afx_msg long glTextureHeight();
	afx_msg long glTextureComponents();
	afx_msg long glTextureBorderColor();
	afx_msg long glTextureBorder();
	afx_msg long glByte();
	afx_msg long glUnsignedByte();
	afx_msg long glShort();
	afx_msg long glUnsignedShort();
	afx_msg long glInt();
	afx_msg long glUnsignedInt();
	afx_msg long glFloat();
	afx_msg long gl2Bytes();
	afx_msg long gl3Bytes();
	afx_msg long gl4Bytes();
	afx_msg long glDoubleExt();
	afx_msg long glClear();
	afx_msg long glAnd();
	afx_msg long glAndReverse();
	afx_msg long glCopy();
	afx_msg long glAndInverted();
	afx_msg long glNoop();
	afx_msg long glXor();
	afx_msg long glOr();
	afx_msg long glNor();
	afx_msg long glEquiv();
	afx_msg long glInvert();
	afx_msg long glOrReverse();
	afx_msg long glCopyInverted();
	afx_msg long glOrInverted();
	afx_msg long glNand();
	afx_msg long glSet();
	afx_msg long glDoublebuffer();
	afx_msg long glAccumBlueBits();
	afx_msg long RenderMode(long mode);
	afx_msg void InitNames();
	afx_msg void PopName();
	afx_msg void AlphaFunc(long func, float ref);
	afx_msg void BlendFunc(long sfactor, long dfactor);
	afx_msg void PushName(long name);
	afx_msg void LoadName(long name);
	afx_msg long glColorIndex();
	afx_msg long glStencilIndex();
	afx_msg long glDepthComponent();
	afx_msg long glRed();
	afx_msg long glGreen();
	afx_msg long glBlue();
	afx_msg long glAlpha();
	afx_msg long glRgb();
	afx_msg long glRgba();
	afx_msg long glLuminance();
	afx_msg long glLuminanceAlpha();
	afx_msg long gluInvalidEnum();
	afx_msg long gluInvalidValue();
	afx_msg long gluOutOfMemory();
	afx_msg long gluIncompatibleGlVersion();
	afx_msg long gluSmooth();
	afx_msg long gluFlat();
	afx_msg long gluNone();
	afx_msg long gluPoint();
	afx_msg long gluLine();
	afx_msg long gluFill();
	afx_msg long gluSilhouette();
	afx_msg long gluOutside();
	afx_msg long gluInside();
	afx_msg void MatrixMode(long mode);
	afx_msg long gluTessWindingRule();
	afx_msg long gluTessBoundaryOnly();
	afx_msg long gluTessTolerance();
	afx_msg long gluTessWindingOdd();
	afx_msg long gluTessWindingNonzero();
	afx_msg long gluTessWindingPositive();
	afx_msg long gluTessWindingNegative();
	afx_msg long gluTessWindingAbsGeqTwo();
	afx_msg long gluTessBegin();
	afx_msg long gluTessVertex();
	afx_msg long gluTessEnd();
	afx_msg long gluTessError();
	afx_msg long gluTessEdgeFlag();
	afx_msg long gluTessCombine();
	afx_msg void LightModelv(long pname, float p0, float p1, float p2, float p3);
	afx_msg void Light(long light, long pname, float param);
	afx_msg void Lightf(long light, long pname, float p0, float p1, float p2, float p3);
	afx_msg void LightModel(long pname, float param);
	afx_msg void Material(long face, long pname, float param);
	afx_msg void Materialv(long face, long pname, float p0, float p1, float p2, float p3);
	afx_msg void GetMaterial(long face, long name, float FAR* p0, float FAR* p1, float FAR* p2, float FAR* p3);
	afx_msg void GetLight(long light, long pname, float FAR* p0, float FAR* p1, float FAR* p2, float FAR* p3);
	afx_msg long gluTessBeginData();
	afx_msg long gluTessVertexData();
	afx_msg long gluTessEndData();
	afx_msg long gluTessErrorData();
	afx_msg long gluTessEdgeFlagData();
	afx_msg long gluTessCombineData();
	afx_msg long gluTessError1();
	afx_msg long gluTessError2();
	afx_msg long gluTessError3();
	afx_msg long gluTessError4();
	afx_msg long gluTessError5();
	afx_msg long gluTessError6();
	afx_msg long gluTessError7();
	afx_msg long gluTessError8();
	afx_msg long gluTessMissingBeginPolygon();
	afx_msg long gluTessMissingBeginContour();
	afx_msg long gluTessMissingEndPolygon();
	afx_msg long gluTessMissingEndContour();
	afx_msg long gluTessCoordTooLarge();
	afx_msg long gluTessNeedCombineCallback();
	afx_msg long gluAutoLoadMatrix();
	afx_msg long gluCulling();
	afx_msg long gluSamplingTolerance();
	afx_msg long gluDisplayMode();
	afx_msg long gluParametricTolerance();
	afx_msg long gluSamplingMethod();
	afx_msg long gluUStep();
	afx_msg long gluVStep();
	afx_msg long gluPathLength();
	afx_msg long gluParametricError();
	afx_msg long gluDomainDistance();
	afx_msg long gluMap1Trim3();
	afx_msg long gluOutlinePolygon();
	afx_msg long gluOutlinePatch();
	afx_msg long GenLists(long range);
	afx_msg long gluMap1Trim2();
	afx_msg double gluTessMaxCoord();
	afx_msg long gluNurbsError1();
	afx_msg long gluNurbsError2();
	afx_msg long gluNurbsError3();
	afx_msg long gluNurbsError4();
	afx_msg long gluNurbsError5();
	afx_msg long gluNurbsError6();
	afx_msg long gluNurbsError7();
	afx_msg long gluNurbsError8();
	afx_msg long gluNurbsError9();
	afx_msg long gluNurbsError10();
	afx_msg long gluNurbsError11();
	afx_msg long gluNurbsError12();
	afx_msg long gluNurbsError13();
	afx_msg long gluNurbsError14();
	afx_msg long gluNurbsError15();
	afx_msg long gluNurbsError16();
	afx_msg long gluNurbsError17();
	afx_msg long gluNurbsError18();
	afx_msg long gluNurbsError19();
	afx_msg long gluNurbsError20();
	afx_msg long gluNurbsError21();
	afx_msg long gluNurbsError22();
	afx_msg long gluNurbsError23();
	afx_msg long gluNurbsError24();
	afx_msg long gluNurbsError25();
	afx_msg long gluNurbsError26();
	afx_msg long gluNurbsError27();
	afx_msg long gluNurbsError28();
	afx_msg long gluNurbsError30();
	afx_msg long gluNurbsError31();
	afx_msg long gluNurbsError32();
	afx_msg long gluNurbsError33();
	afx_msg long gluNurbsError34();
	afx_msg long gluNurbsError35();
	afx_msg long gluNurbsError36();
	afx_msg long gluNurbsError37();
	afx_msg void LoadMatrix(float FAR* matrix);
	afx_msg void MultMatrix(float FAR* matrix);
	afx_msg void ColorMask(BOOL bRed, BOOL bGreen, BOOL bBlue, BOOL bAlpha);
	afx_msg void Fogv(long pName, float p0, float p1, float p2, float p3);
	afx_msg void Fog(long pName, float param);
	afx_msg void GLBEGIN(long primtype);
	afx_msg void GLEND();
	afx_msg void CopyPixels(long x, long y, long w, long h, long typ);
	afx_msg void RasterPos2(float x, float y);
	afx_msg void RasterPos3(float x, float y, float z);
	afx_msg void RasterPos4(float x, float y, float z, float w);
	afx_msg void PixelStore(long name, float param);
	afx_msg void DrawPixels(long w, long h, long format, long ptype, VARIANT FAR* pixels);
	afx_msg void ReadPixels(long x, long y, long w, long h, long pformat, long ptype, VARIANT FAR* pPixels);
	afx_msg void Bitmap(long width, long height, float xorg, float yorg, float xmove, float ymove, VARIANT FAR* pBitmap);
	afx_msg void CallLists(long listSize, long listType, VARIANT FAR* listData);
	afx_msg void PixelZoom(float xFactor, float yFactor);
	afx_msg void PixelMap(long map, long mapSize, VARIANT FAR* values);
	afx_msg void PixelTransfer(long pName, float Param);
	afx_msg void GetPixelMap(long map, VARIANT FAR* pValues);
	afx_msg void gluBuild2dMipmaps(long target, long comp, long width, long height, long format, long gtype, VARIANT FAR* pData);
	afx_msg void gluBuild1DMipmaps(long target, long comp, long width, long format, long gtype, VARIANT FAR* pData);
	afx_msg void gluPickMatrix(double x, double y, double width, double height, VARIANT FAR* viewport);
	afx_msg void gluScaleImage(long format, long widthin, long heightin, long typein, VARIANT FAR* datain, long widthout, long heightout, long typeout, VARIANT FAR* dataout);
	afx_msg void SelectBuffer(long size, VARIANT FAR* pBuffer);
	afx_msg void FeedbackBuffer(long size, long buffType, VARIANT FAR* pBuffer);
	afx_msg long gluNewQuadric();
	afx_msg void gluDeleteQuadric(long lQuadric);
	afx_msg void gluQuadricNormals(long lObject, long lNormals);
	afx_msg void gluQuadricOrientation(long lObject, long lOrientation);
	afx_msg void gluQuadricDrawStyle(long lObject, long lStyle);
	afx_msg void gluCylinder(long lObject, double baseRadius, double topRadius, double heightVal, long iSlices, long iStacks);
	afx_msg void gluPartialDisk(long lObject, double innerRadius, double outerRadius, long iSlices, long iLoops, double startAngle, double sweepAngle);
	afx_msg void gluDisk(long lObject, double innerRadius, double outerRadius, long iSlices, long iLoops);
	afx_msg void gluSphere(long lObject, double dRadius, long iSlices, long iStacks);
	afx_msg void gluQuadricTexture(long lObject, BOOL bCoords);
	afx_msg void gluBeginPolygon(long lTesselator);
	afx_msg void gluEndPolygon(long lTesselator);
	afx_msg long gluNewTess();
	afx_msg void gluDeleteTess(long lTesselator);
	afx_msg void gluNextCountour(long lTesselator, long lType);
	afx_msg void gluTessNormal(long lTesselator, double x, double y, double z);
	afx_msg void gluTessProperty(long lTesselator, long lWhich, double dValue);
	afx_msg void gluGetTessProperty(long lTesselator, long lWhich, double FAR* dValue);
	afx_msg void gluTessBeginPolygon(long lTesselator, VARIANT FAR* pData);
	afx_msg void gluTessEndPolygon(long lTesselator);
	afx_msg void gluTessBeginContour(long lTesselator);
	afx_msg void gluTessEndContour(long lTesselator);
	afx_msg BOOL IsEnabled(long lValue);
	afx_msg void GetFloatv(long lEnum, float FAR* pParams);
	afx_msg void GetBooleanv(long lEnum, BOOL FAR* pData);
	afx_msg void GetDoublev(long lEnum, double FAR* pData);
	afx_msg void GetInteger(long lEnum, long FAR* pData);
	afx_msg void PushAttrib(long lMask);
	afx_msg void PopAttrib();
	afx_msg void Accum(long lOperand, float fValue);
	afx_msg void ClearStencil(long sValue);
	afx_msg void ClearDepth(double dValue);
	afx_msg void StencilMask(long lMask);
	afx_msg void ClearAccum(float fRed, float fGreen, float fBlue, float fAlpha);
	afx_msg void StencilFunc(long lFunc, long lRef, long lMask);
	afx_msg void DepthFunc(long lFunc);
	afx_msg void DepthRange(double dNear, double dFar);
	afx_msg void ReadBuffer(long lMode);
	afx_msg void ClipPlane(long lPlane, double dA, double dB, double dC, double dD);
	afx_msg void Scissor(long x, long y, long lWidth, long lHeight);
	afx_msg void StencilOp(long fail, long zfail, long zpass);
	afx_msg void DrawBuffer(long lMode);
	afx_msg void DepthMask(BOOL bMask);
	afx_msg void GetClipPlane(long lPlane, double FAR* dpa, double FAR* dpb, double FAR* dpc, double FAR* dpd);
	afx_msg long gluNewNurbsRenderer();
	afx_msg void gluDeleteNurbsRenderer(long lNurbObj);
	afx_msg void gluBeginSurface(long lObj);
	afx_msg void gluEndCurve(long lObj);
	afx_msg void gluBeginTrim(long lObj);
	afx_msg void gluBeginCurve(long lObj);
	afx_msg void gluEndSurface(long lObj);
	afx_msg void gluEndTrim(long lObj);
	afx_msg void gluPwlCurve(long lObj, long lCount, float FAR* pPoints, long lStride, long lType);
	afx_msg void gluNurbsCurve(long lObj, long lKnots, float FAR* pKnots, long lStride, float FAR* pControl, long lOrder, long lType);
	afx_msg void gluNurbsSurface(long lObj, long sKnot, float FAR* psKnots, long tKnot, float FAR* ptKnots, long sStride, long tStride, float FAR* pCtlPoints, long sOrder, long tOrder, long lType);
	afx_msg void gluNurbsProperty(long lObj, long lProperty, float fValue);
	afx_msg void gluGetNurbsProperty(long lObj, long lProperty, float FAR* pfValue);
	afx_msg void GetMap(long lTarget, long lQuery, float FAR* pfValues);
	afx_msg void EvalCoord1(float fU);
	afx_msg void EvalCoord2(float fU, float fV);
	afx_msg void EvalMesh1(long lMode, long l1, long l2);
	afx_msg void EvalMesh2(long lMode, long l1, long l2, long l3, long l4);
	afx_msg void EvalPoint1(long i);
	afx_msg void EvalPoint2(long i, long j);
	afx_msg void Map1(long lTarget, float u1, float u2, long iStride, long iOrder, float FAR* pPoints);
	afx_msg void Map2(long lTarget, float u1, float u2, long uStride, long uOrder, float v1, float v2, long ivstride, long ivorder, float FAR* pData);
	afx_msg void MapGrid1(long un, float v1, float v2);
	afx_msg void MapGrid2(long un, float u1, float u2, long vn, float v1, float v2);
	afx_msg void GetTexEnvfv(long lTarget, long lPname, float FAR* pParams);
	afx_msg void GetTexGenfv(long lCoord, long lPName, float FAR* pParams);
	afx_msg void GetTexLevelParameterfv(long lTarget, long lLevel, long lPname, float FAR* pParams);
	afx_msg void GetTexParameterfv(long lTarget, long lPname, float FAR* pParams);
	afx_msg void TexCoord1f(float fS);
	afx_msg void TexCoord2f(float fS, float fT);
	afx_msg void TexCoord3f(float fS, float fT, float fR);
	afx_msg void TexCoord4f(float fS, float fT, float fR, float fQ);
	afx_msg void TexEnvf(long lTarget, long lPName, float fParam);
	afx_msg void TexEnvfv(long lTarget, long lPname, float FAR* pParams);
	afx_msg void TexGenf(long lCoord, long lName, float fParam);
	afx_msg void TexGenfv(long lCoord, long lPname, float FAR* pfParams);
	afx_msg void TexParameterf(long lTarget, long lPname, float fParam);
	afx_msg void TexParameterfv(long lTarget, long lPname, float FAR* pfParams);
	afx_msg void TexImage1D(long lTarget, long lLevel, long lComponent, long lWidth, long lBorder, long lFormat, long lType, VARIANT FAR* pPixels);
	afx_msg void TexImage2D(long lTarget, long lLevel, long lComponent, long lWidth, long lHeight, long lBorder, long lFormat, long lType, VARIANT FAR* pPixels);
	afx_msg void PassThrough(float fToken);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CWaiteGLCtrl)
	void FireRender()
		{FireEvent(eventidRender,EVENT_PARAM(VTS_NONE));}
	void FireSetupRC()
		{FireEvent(eventidSetupRC,EVENT_PARAM(VTS_NONE));}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CWaiteGLCtrl)
	dispidFlush = 1L,
	dispidClearColor = 2L,
	dispidClear = 3L,
	dispidGlColorBufferBit = 4L,
	dispidSwapBuffers = 5L,
	dispidMakeCurrent = 6L,
	dispidMakeNotCurrent = 7L,
	dispidColor = 8L,
	dispidRect = 9L,
	dispidOrtho = 10L,
	dispidAuxSolidTeapot = 11L,
	dispidAuxWireTeapot = 12L,
	dispidRotate = 13L,
	dispidLoadIdentity = 14L,
	dispidGluPerspective = 15L,
	dispidGlAccum = 16L,
	dispidAuxSolidSphere = 17L,
	dispidAuxWireSphere = 18L,
	dispidAuxWireCube = 19L,
	dispidAuxSolidCube = 20L,
	dispidAuxWireBox = 21L,
	dispidAuxSolidBox = 22L,
	dispidAuxSolidTorus = 23L,
	dispidAuxWireTorus = 24L,
	dispidAuxWireCylinder = 25L,
	dispidAuxSolidCylinder = 26L,
	dispidAuxWireIcosahedron = 27L,
	dispidAuxSolidIcosahedron = 28L,
	dispidAuxWireOctahedron = 29L,
	dispidAuxSolidOctahedron = 30L,
	dispidAuxWireDodecahedron = 31L,
	dispidAuxSolidDodecahedron = 32L,
	dispidAuxWireCone = 33L,
	dispidAuxSolidCone = 34L,
	dispidViewport = 35L,
	dispidWglGetRC = 36L,
	dispidWglGetDC = 37L,
	dispidWglUseFontBitmaps = 38L,
	dispidBegin = 39L,
	dispidEnd = 40L,
	dispidEnable = 41L,
	dispidDisable = 42L,
	dispidGlLoad = 43L,
	dispidGlReturn = 44L,
	dispidGlMult = 45L,
	dispidGlAdd = 46L,
	dispidGlNever = 47L,
	dispidGlLess = 48L,
	dispidGlEqual = 49L,
	dispidGlLequal = 50L,
	dispidGlGreater = 51L,
	dispidGlNotequal = 52L,
	dispidGlGequal = 53L,
	dispidGlAlways = 54L,
	dispidGlPoints = 55L,
	dispidGlLines = 56L,
	dispidGlLineLoop = 57L,
	dispidGlLineStrip = 58L,
	dispidGlTriangles = 59L,
	dispidGlTriangleStrip = 60L,
	dispidGlTriangleFan = 61L,
	dispidGlQuads = 62L,
	dispidGlQuadStrip = 63L,
	dispidGlPolygon = 64L,
	dispidNormal = 65L,
	dispidGlCurrentBit = 66L,
	dispidGlPointbit = 67L,
	dispidGlLineBit = 68L,
	dispidGlPolygonBit = 69L,
	dispidGlPolygonStippleBit = 70L,
	dispidGlPixelModeBit = 71L,
	dispidGlLightingBit = 72L,
	dispidGlFogBit = 73L,
	dispidGlDepthBufferBit = 74L,
	dispidGlAccumBufferBit = 75L,
	dispidGlStencilBufferbit = 76L,
	dispidGlViewportBit = 77L,
	dispidGlTransformBit = 78L,
	dispidGlEnableBit = 79L,
	dispidGlHintBit = 80L,
	dispidGlEvalBit = 81L,
	dispidGlListBit = 82L,
	dispidGlTextureBit = 83L,
	dispidGlScissorBit = 84L,
	dispidGlAllAttribBits = 85L,
	dispidGlNoError = 86L,
	dispidGlInvalidEnum = 87L,
	dispidGlInvalidValue = 88L,
	dispidGlInvalidOperation = 89L,
	dispidGlStackOverflow = 90L,
	dispidGlStackUnderflow = 91L,
	dispidGlOutOfMemory = 92L,
	dispidGlDontCare = 93L,
	dispidGlFastest = 94L,
	dispidGlNicest = 95L,
	dispidGlLight0 = 96L,
	dispidGlLight1 = 97L,
	dispidGlLight2 = 98L,
	dispidGlLight3 = 99L,
	dispidGlLight4 = 100L,
	dispidGlLight5 = 101L,
	dispidGlLight6 = 102L,
	dispidGlLight7 = 103L,
	dispidGlAmbient = 104L,
	dispidGlDiffuse = 105L,
	dispidGlSpecular = 106L,
	dispidGlPosition = 107L,
	dispidGlSpotDirection = 108L,
	dispidGlSpotExponent = 109L,
	dispidGlSpotCutoff = 110L,
	dispidGlConstantAttenuation = 111L,
	dispidGlLinearAttenuation = 112L,
	dispidGlQuadraticAttenuation = 113L,
	dispidGlEmission = 114L,
	dispidGlShininess = 115L,
	dispidGlAmbientAndDiffuse = 116L,
	dispidGlColorIndexes = 117L,
	dispidGlModelview = 118L,
	dispidGlProjection = 119L,
	dispidGlTexture = 120L,
	dispidEndList = 121L,
	dispidCallList = 122L,
	dispidNewList = 123L,
	dispidDeleteLists = 124L,
	dispidGlColor = 125L,
	dispidGlDepth = 126L,
	dispidGlStencil = 127L,
	dispidGlFlat = 128L,
	dispidGlSmooth = 129L,
	dispidGlPoint = 130L,
	dispidGlLine = 131L,
	dispidGlFill = 132L,
	dispidGlCw = 133L,
	dispidGlCcw = 134L,
	dispidGlCurrentColor = 135L,
	dispidGlCurrentIndex = 136L,
	dispidGlCurrentNormal = 137L,
	dispidGlCurrentTextureCoords = 138L,
	dispidGlCurrentRasterColor = 139L,
	dispidGlCurrentRasterIndex = 140L,
	dispidGlCurrentRasterTextureCoords = 141L,
	dispidGlCurrentRasterPosition = 142L,
	dispidGlCurrentRasterPositionValid = 143L,
	dispidGlCurrentRasterDistance = 144L,
	dispidGlPointSmooth = 145L,
	dispidGlPointSize = 146L,
	dispidGlPointSizeRange = 147L,
	dispidGlPointSizeGranularity = 148L,
	dispidGlLineSmooth = 149L,
	dispidGlLineWidth = 150L,
	dispidGlLineWidthRange = 151L,
	dispidGlLineWidthGranularity = 152L,
	dispidGlLineStipple = 153L,
	dispidGlLineStipplePattern = 154L,
	dispidGlLineStippleRepeat = 155L,
	dispidGlListMode = 156L,
	dispidGlMaxListNesting = 157L,
	dispidGlListBase = 158L,
	dispidGlListIndex = 159L,
	dispidGlPolygonMode = 160L,
	dispidGlPolygonSmooth = 161L,
	dispidGlPolygonStipple = 162L,
	dispidGlEdgeFlag = 163L,
	dispidGlCullFace = 164L,
	dispidGlCullFaceMode = 165L,
	dispidGlFrontFace = 166L,
	dispidGlLighting = 167L,
	dispidGlLightModelLocalViewer = 168L,
	dispidGlLightModelTwoSide = 169L,
	dispidGlLightModelAmbient = 170L,
	dispidGlShadeModel = 171L,
	dispidGlColorMaterialFace = 172L,
	dispidGlColorMaterialParameter = 173L,
	dispidGlColorMaterial = 174L,
	dispidGlFog = 175L,
	dispidGlFogIndex = 176L,
	dispidGlFogDensity = 177L,
	dispidGlFogStart = 178L,
	dispidGlFogEnd = 179L,
	dispidGlFogMode = 180L,
	dispidGlFogColor = 181L,
	dispidGlDepthRange = 182L,
	dispidGlDepthTest = 183L,
	dispidGlDepthWritemask = 184L,
	dispidGlDepthClearValue = 185L,
	dispidGlDepthFunc = 186L,
	dispidGlAccumClearValue = 187L,
	dispidGlStencilTest = 188L,
	dispidGlStencilClearValue = 189L,
	dispidGlStencilFunc = 190L,
	dispidGlStencilValueMask = 191L,
	dispidGlStencilFail = 192L,
	dispidGlStencilPassDepthFail = 193L,
	dispidGlStencilPassDepthPass = 194L,
	dispidGlStencilRef = 195L,
	dispidGlStencilWritemask = 196L,
	dispidGlMatrixMode = 197L,
	dispidGlNormalize = 198L,
	dispidGlViewport = 199L,
	dispidGlModelviewStackDepth = 200L,
	dispidGlProjectionStackDepth = 201L,
	dispidGlTextureStackDepth = 202L,
	dispidGlModelviewMatrix = 203L,
	dispidGlProjectionMatrix = 204L,
	dispidGlTextureMatrix = 205L,
	dispidGlAttribStackDepth = 206L,
	dispidGlCompile = 207L,
	dispidGlCompileAndExecute = 208L,
	dispidGlBitmap = 209L,
	dispidGlRender = 210L,
	dispidGlFeedback = 211L,
	dispidGlSelect = 212L,
	dispidGlVendor = 213L,
	dispidGlRenderer = 214L,
	dispidGlVersion = 215L,
	dispidGlExtensions = 216L,
	dispidGlAlphaTest = 217L,
	dispidGlAlphaTestFunc = 218L,
	dispidGlAlphaTestRef = 219L,
	dispidGlDither = 220L,
	dispidFrontFace = 221L,
	dispidStart = 222L,
	dispidStop = 223L,
	dispidPushMatrix = 224L,
	dispidPopMatrix = 225L,
	dispidTranslate = 226L,
	dispidScale = 227L,
	dispidIsList = 228L,
	dispidListBase = 229L,
	dispidLineStipple = 230L,
	dispidLineWidth = 231L,
	dispidPointSize = 232L,
	dispidVertex2 = 233L,
	dispidVertex3 = 234L,
	dispidVertex4 = 235L,
	dispidGlClamp = 236L,
	dispidGlRepeat = 237L,
	dispidPolygonStipple = 238L,
	dispidPolygonMode = 239L,
	dispidEdgeFlag = 240L,
	dispidGetPolygonStipple = 241L,
	dispidFrustum = 242L,
	dispidGluLookAt = 243L,
	dispidGluOrtho2D = 244L,
	dispidHint = 245L,
	dispidShadeModel = 246L,
	dispidCullFace = 247L,
	dispidGlNearest = 248L,
	dispidGlLinear = 249L,
	dispidGlTextureMagFilter = 250L,
	dispidGlTextureMinFilter = 251L,
	dispidGlTextureWrapS = 252L,
	dispidGlTextureWrapT = 253L,
	dispidGlNearestMipmapNearest = 254L,
	dispidGlLinearMipmapNearest = 255L,
	dispidGlNearestMipmapLinear = 256L,
	dispidGlLinearMipmapLinear = 257L,
	dispidGluErrorString = 258L,
	dispidGetString = 259L,
	dispidGetError = 260L,
	dispidGluGetString = 261L,
	dispidGlKeep = 262L,
	dispidGlReplace = 263L,
	dispidGlIncr = 264L,
	dispidGlDecr = 265L,
	dispidGlS = 266L,
	dispidGlT = 267L,
	dispidGlR = 268L,
	dispidGlQ = 269L,
	dispidGlModulate = 270L,
	dispidGlDecal = 271L,
	dispidGlTextureEnvMode = 272L,
	dispidGlTextureEnvColor = 273L,
	dispidGlTextureEnv = 274L,
	dispidGlEyeLinear = 275L,
	dispidGlObjectLinear = 276L,
	dispidGlSphereMap = 277L,
	dispidGlTextureGenMode = 278L,
	dispidGlObjectPlane = 279L,
	dispidGlEyePlane = 280L,
	dispidGluVersion = 281L,
	dispidGluExtensions = 282L,
	dispidGlZero = 283L,
	dispidGlOne = 284L,
	dispidGlSrcColor = 285L,
	dispidGlOneMinusSrcColor = 286L,
	dispidGlSrcAlpha = 287L,
	dispidGlOneMinusSrcAlpha = 288L,
	dispidGlDstAlpha = 289L,
	dispidGlOneMinusDstAlpha = 290L,
	dispidGlDstColor = 291L,
	dispidGlOneMinusDstColor = 292L,
	dispidGlSrcAlphaSaturate = 293L,
	dispidGlClipPlane0 = 294L,
	dispidGlClipPlane1 = 295L,
	dispidGlClipPlane2 = 296L,
	dispidGlClipPlane3 = 297L,
	dispidGlClipPlane4 = 298L,
	dispidGlClipPlane5 = 299L,
	dispidGlNone = 300L,
	dispidGlFrontLeft = 301L,
	dispidGlFrontRight = 302L,
	dispidGlBackLeft = 303L,
	dispidGlBackRight = 304L,
	dispidGlFront = 305L,
	dispidGlBack = 306L,
	dispidGlLeft = 307L,
	dispidGlRight = 308L,
	dispidGlFrontAndBack = 309L,
	dispidGlAux0 = 310L,
	dispidGlAux1 = 311L,
	dispidGlAux2 = 312L,
	dispidGlAux3 = 313L,
	dispidGl2d = 314L,
	dispidGl3d = 315L,
	dispidGl3dColor = 316L,
	dispidGl3dColorTexture = 317L,
	dispidGl4dColorTexture = 318L,
	dispidGlPassThroughToken = 319L,
	dispidGlPointToken = 320L,
	dispidGlLineToken = 321L,
	dispidGlPolygonToken = 322L,
	dispidGlBitmapToken = 323L,
	dispidGlDrawPixelToken = 324L,
	dispidGlCopyPixelToken = 325L,
	dispidGlLineResetToken = 326L,
	dispidGlExp = 327L,
	dispidGlExp2 = 328L,
	dispidGlCoeff = 329L,
	dispidGlOrder = 330L,
	dispidGlDomain = 331L,
	dispidGlBlendDst = 332L,
	dispidGlBlendSrc = 333L,
	dispidGlBlend = 334L,
	dispidGlLogicOpMode = 335L,
	dispidGlLogicOp = 336L,
	dispidGlAuxBuffers = 337L,
	dispidGlDrawBuffer = 338L,
	dispidGlReadBuffer = 339L,
	dispidGlScissorBox = 340L,
	dispidGlScissorTest = 341L,
	dispidGlIndexClearValue = 342L,
	dispidGlIndexWritemask = 343L,
	dispidGlColorClearValue = 344L,
	dispidGlColorWritemask = 345L,
	dispidGlIndexMode = 346L,
	dispidGlRgbaMode = 347L,
	dispidColorMaterial = 348L,
	dispidGlStereo = 349L,
	dispidGlRenderMode = 350L,
	dispidGlPerspectiveCorrectionHint = 351L,
	dispidGlPointSmoothHint = 352L,
	dispidGlLineSmoothHint = 353L,
	dispidGlPolygonSmoothHint = 354L,
	dispidGlFogHint = 355L,
	dispidGlTextureGenS = 356L,
	dispidGlTextureGenT = 357L,
	dispidGlTextureGenR = 358L,
	dispidGlTextureGenQ = 359L,
	dispidGlPixelMapIToI = 360L,
	dispidGlPixelMapSToS = 361L,
	dispidGlPixelMapIToR = 362L,
	dispidGlPixelMapIToG = 363L,
	dispidGlPixelMapIToB = 364L,
	dispidGlPixelMapIToA = 365L,
	dispidGlPixelMapRToR = 366L,
	dispidGlPixelMapGToG = 367L,
	dispidGlPixelMapBToB = 368L,
	dispidGlPixelMapAToA = 369L,
	dispidGlPixelMapIToISize = 370L,
	dispidGlPixelMapSToSSize = 371L,
	dispidGlPixelMapIToRSize = 372L,
	dispidGlPixelMapIToGSize = 373L,
	dispidGlPixelMapIToBSize = 374L,
	dispidGlPixelMapIToASize = 375L,
	dispidGlPixelMapRToRSize = 376L,
	dispidGlPixelMapGToGSize = 377L,
	dispidGlPixelMapBToBSize = 378L,
	dispidGlPixelMapAToASize = 379L,
	dispidGlUnpackSwapBytes = 380L,
	dispidGlUnpackLsbFirst = 381L,
	dispidGlUnpackRowLength = 382L,
	dispidGlUnpackSkipRows = 383L,
	dispidGlUnpackSkipPixels = 384L,
	dispidGlUnpackAlignment = 385L,
	dispidGlPackSwapBytes = 386L,
	dispidGlPackLsbFirst = 387L,
	dispidGlPackRowLength = 388L,
	dispidGlPackSkipRows = 389L,
	dispidGlPackSkipPixels = 390L,
	dispidGlPackAlignment = 391L,
	dispidGlMapColor = 392L,
	dispidGlMapStencil = 393L,
	dispidGlIndexShift = 394L,
	dispidGlIndexOffset = 395L,
	dispidGlRedScale = 396L,
	dispidGlRedBias = 397L,
	dispidGlZoomX = 398L,
	dispidGlZoomY = 399L,
	dispidGlGreenScale = 400L,
	dispidGlGreenBias = 401L,
	dispidGlBlueScale = 402L,
	dispidGlBlueBias = 403L,
	dispidGlAlphaScale = 404L,
	dispidGlAlphaBias = 405L,
	dispidGlDepthScale = 406L,
	dispidGlDepthBias = 407L,
	dispidGlMaxEvalOrder = 408L,
	dispidGlMaxLights = 409L,
	dispidGlMaxClipPlanes = 410L,
	dispidGlMaxTextureSize = 411L,
	dispidGlMaxPixelMapTable = 412L,
	dispidGlMaxAttribStackDepth = 413L,
	dispidGlMaxModelviewStackDepth = 414L,
	dispidGlMaxNameStackDepth = 415L,
	dispidGlMaxProjectionStackDepth = 416L,
	dispidGlMaxTextureStackDepth = 417L,
	dispidGlMaxViewportDims = 418L,
	dispidGlSubpixelBits = 419L,
	dispidGlIndexBits = 420L,
	dispidGlRedBits = 421L,
	dispidGlGreenBits = 422L,
	dispidGlBlueBits = 423L,
	dispidGlAlphaBits = 424L,
	dispidGlDepthBits = 425L,
	dispidGlStencilBits = 426L,
	dispidGlAccumRedBits = 427L,
	dispidGlAccumGreenBits = 428L,
	dispidGlAccumAlphaBits = 429L,
	dispidGlNameStackDepth = 430L,
	dispidGlAutoNormal = 431L,
	dispidGlMap1Color4 = 432L,
	dispidGlMap1Index = 433L,
	dispidGlMap1Normal = 434L,
	dispidGlMap1TextureCoord1 = 435L,
	dispidGlMap1TextureCoord2 = 436L,
	dispidGlMap1TextureCoord3 = 437L,
	dispidGlMap1TextureCoord4 = 438L,
	dispidGlMap1Vertex3 = 439L,
	dispidGlMap1Vertex4 = 440L,
	dispidGlMap2Color4 = 441L,
	dispidGlMap2Index = 442L,
	dispidGlMap2Normal = 443L,
	dispidGlMap2TextureCoord1 = 444L,
	dispidGlMap2TextureCoord2 = 445L,
	dispidGlMap2TextureCoord3 = 446L,
	dispidGlMap2TextureCoord4 = 447L,
	dispidGlMap2Vertex3 = 448L,
	dispidGlMap2Vertex4 = 449L,
	dispidGlMap1GridDomain = 450L,
	dispidGlMap1GridSegments = 451L,
	dispidGlMap2GridDomain = 452L,
	dispidGlMap2GridSegments = 453L,
	dispidGlTexture1d = 454L,
	dispidGlTexture2d = 455L,
	dispidGlTextureWidth = 456L,
	dispidGlTextureHeight = 457L,
	dispidGlTextureComponents = 458L,
	dispidGlTextureBorderColor = 459L,
	dispidGlTextureBorder = 460L,
	dispidGlByte = 461L,
	dispidGlUnsignedByte = 462L,
	dispidGlShort = 463L,
	dispidGlUnsignedShort = 464L,
	dispidGlInt = 465L,
	dispidGlUnsignedInt = 466L,
	dispidGlFloat = 467L,
	dispidGl2Bytes = 468L,
	dispidGl3Bytes = 469L,
	dispidGl4Bytes = 470L,
	dispidGlDoubleExt = 471L,
	dispidGlClear = 472L,
	dispidGlAnd = 473L,
	dispidGlAndReverse = 474L,
	dispidGlCopy = 475L,
	dispidGlAndInverted = 476L,
	dispidGlNoop = 477L,
	dispidGlXor = 478L,
	dispidGlOr = 479L,
	dispidGlNor = 480L,
	dispidGlEquiv = 481L,
	dispidGlInvert = 482L,
	dispidGlOrReverse = 483L,
	dispidGlCopyInverted = 484L,
	dispidGlOrInverted = 485L,
	dispidGlNand = 486L,
	dispidGlSet = 487L,
	dispidGlDoublebuffer = 488L,
	dispidGlAccumBlueBits = 489L,
	dispidRenderMode = 490L,
	dispidInitNames = 491L,
	dispidPopName = 492L,
	dispidAlphaFunc = 493L,
	dispidBlendFunc = 494L,
	dispidPushName = 495L,
	dispidLoadName = 496L,
	dispidGlColorIndex = 497L,
	dispidGlStencilIndex = 498L,
	dispidGlDepthComponent = 499L,
	dispidGlRed = 500L,
	dispidGlGreen = 501L,
	dispidGlBlue = 502L,
	dispidGlAlpha = 503L,
	dispidGlRgb = 504L,
	dispidGlRgba = 505L,
	dispidGlLuminance = 506L,
	dispidGlLuminanceAlpha = 507L,
	dispidGluInvalidEnum = 508L,
	dispidGluInvalidValue = 509L,
	dispidGluOutOfMemory = 510L,
	dispidGluIncompatibleGlVersion = 511L,
	dispidGluSmooth = 512L,
	dispidGluFlat = 513L,
	dispidGluNone = 514L,
	dispidGluPoint = 515L,
	dispidGluLine = 516L,
	dispidGluFill = 517L,
	dispidGluSilhouette = 518L,
	dispidGluOutside = 519L,
	dispidGluInside = 520L,
	dispidMatrixMode = 521L,
	dispidGluTessWindingRule = 522L,
	dispidGluTessBoundaryOnly = 523L,
	dispidGluTessTolerance = 524L,
	dispidGluTessWindingOdd = 525L,
	dispidGluTessWindingNonzero = 526L,
	dispidGluTessWindingPositive = 527L,
	dispidGluTessWindingNegative = 528L,
	dispidGluTessWindingAbsGeqTwo = 529L,
	dispidGluTessBegin = 530L,
	dispidGluTessVertex = 531L,
	dispidGluTessEnd = 532L,
	dispidGluTessError = 533L,
	dispidGluTessEdgeFlag = 534L,
	dispidGluTessCombine = 535L,
	dispidLightModelv = 536L,
	dispidLight = 537L,
	dispidLightf = 538L,
	dispidLightModel = 539L,
	dispidMaterial = 540L,
	dispidMaterialv = 541L,
	dispidGetMaterial = 542L,
	dispidGetLight = 543L,
	dispidGluTessBeginData = 544L,
	dispidGluTessVertexData = 545L,
	dispidGluTessEndData = 546L,
	dispidGluTessErrorData = 547L,
	dispidGluTessEdgeFlagData = 548L,
	dispidGluTessCombineData = 549L,
	dispidGluTessError1 = 550L,
	dispidGluTessError2 = 551L,
	dispidGluTessError3 = 552L,
	dispidGluTessError4 = 553L,
	dispidGluTessError5 = 554L,
	dispidGluTessError6 = 555L,
	dispidGluTessError7 = 556L,
	dispidGluTessError8 = 557L,
	dispidGluTessMissingBeginPolygon = 558L,
	dispidGluTessMissingBeginContour = 559L,
	dispidGluTessMissingEndPolygon = 560L,
	dispidGluTessMissingEndContour = 561L,
	dispidGluTessCoordTooLarge = 562L,
	dispidGluTessNeedCombineCallback = 563L,
	dispidGluAutoLoadMatrix = 564L,
	dispidGluCulling = 565L,
	dispidGluSamplingTolerance = 566L,
	dispidGluDisplayMode = 567L,
	dispidGluParametricTolerance = 568L,
	dispidGluSamplingMethod = 569L,
	dispidGluUStep = 570L,
	dispidGluVStep = 571L,
	dispidGluPathLength = 572L,
	dispidGluParametricError = 573L,
	dispidGluDomainDistance = 574L,
	dispidGluMap1Trim3 = 575L,
	dispidGluOutlinePolygon = 576L,
	dispidGluOutlinePatch = 577L,
	dispidGenLists = 578L,
	dispidGluMap1Trim2 = 579L,
	dispidGluTessMaxCoord = 580L,
	dispidGluNurbsError1 = 581L,
	dispidGluNurbsError2 = 582L,
	dispidGluNurbsError3 = 583L,
	dispidGluNurbsError4 = 584L,
	dispidGluNurbsError5 = 585L,
	dispidGluNurbsError6 = 586L,
	dispidGluNurbsError7 = 587L,
	dispidGluNurbsError8 = 588L,
	dispidGluNurbsError9 = 589L,
	dispidGluNurbsError10 = 590L,
	dispidGluNurbsError11 = 591L,
	dispidGluNurbsError12 = 592L,
	dispidGluNurbsError13 = 593L,
	dispidGluNurbsError14 = 594L,
	dispidGluNurbsError15 = 595L,
	dispidGluNurbsError16 = 596L,
	dispidGluNurbsError17 = 597L,
	dispidGluNurbsError18 = 598L,
	dispidGluNurbsError19 = 599L,
	dispidGluNurbsError20 = 600L,
	dispidGluNurbsError21 = 601L,
	dispidGluNurbsError22 = 602L,
	dispidGluNurbsError23 = 603L,
	dispidGluNurbsError24 = 604L,
	dispidGluNurbsError25 = 605L,
	dispidGluNurbsError26 = 606L,
	dispidGluNurbsError27 = 607L,
	dispidGluNurbsError28 = 608L,
	dispidGluNurbsError30 = 609L,
	dispidGluNurbsError31 = 610L,
	dispidGluNurbsError32 = 611L,
	dispidGluNurbsError33 = 612L,
	dispidGluNurbsError34 = 613L,
	dispidGluNurbsError35 = 614L,
	dispidGluNurbsError36 = 615L,
	dispidGluNurbsError37 = 616L,
	dispidLoadMatrix = 617L,
	dispidMultMatrix = 618L,
	dispidColorMask = 619L,
	dispidFogv = 620L,
	dispidFog = 621L,
	dispidGLBEGIN = 622L,
	dispidGLEND = 623L,
	dispidCopyPixels = 624L,
	dispidRasterPos2 = 625L,
	dispidRasterPos3 = 626L,
	dispidRasterPos4 = 627L,
	dispidPixelStore = 628L,
	dispidDrawPixels = 629L,
	dispidReadPixels = 630L,
	dispidBitmap = 631L,
	dispidCallLists = 632L,
	dispidPixelZoom = 633L,
	dispidPixelMap = 634L,
	dispidPixelTransfer = 635L,
	dispidGetPixelMap = 636L,
	dispidGluBuild2dMipmaps = 637L,
	dispidGluBuild1DMipmaps = 638L,
	dispidGluPickMatrix = 639L,
	dispidGluScaleImage = 640L,
	dispidSelectBuffer = 641L,
	dispidFeedbackBuffer = 642L,
	dispidGluNewQuadric = 643L,
	dispidGluDeleteQuadric = 644L,
	dispidGluQuadricNormals = 645L,
	dispidGluQuadricOrientation = 646L,
	dispidGluQuadricDrawStyle = 647L,
	dispidGluCylinder = 648L,
	dispidGluPartialDisk = 649L,
	dispidGluDisk = 650L,
	dispidGluSphere = 651L,
	dispidGluQuadricTexture = 652L,
	dispidGluBeginPolygon = 653L,
	dispidGluEndPolygon = 654L,
	dispidGluNewTess = 655L,
	dispidGluDeleteTess = 656L,
	dispidGluNextCountour = 657L,
	dispidGluTessNormal = 658L,
	dispidGluTessProperty = 659L,
	dispidGluGetTessProperty = 660L,
	dispidGluTessBeginPolygon = 661L,
	dispidGluTessEndPolygon = 662L,
	dispidGluTessBeginContour = 663L,
	dispidGluTessEndContour = 664L,
	dispidIsEnabled = 665L,
	dispidGetFloatv = 666L,
	dispidGetBooleanv = 667L,
	dispidGetDoublev = 668L,
	dispidGetInteger = 669L,
	dispidPushAttrib = 670L,
	dispidPopAttrib = 671L,
	dispidAccum = 672L,
	dispidClearStencil = 673L,
	dispidClearDepth = 674L,
	dispidStencilMask = 675L,
	dispidClearAccum = 676L,
	dispidStencilFunc = 677L,
	dispidDepthFunc = 678L,
	dispidDepthRange = 679L,
	dispidReadBuffer = 680L,
	dispidClipPlane = 681L,
	dispidScissor = 682L,
	dispidStencilOp = 683L,
	dispidDrawBuffer = 684L,
	dispidDepthMask = 685L,
	dispidGetClipPlane = 686L,
	dispidGluNewNurbsRenderer = 687L,
	dispidGluDeleteNurbsRenderer = 688L,
	dispidGluBeginSurface = 689L,
	dispidGluEndCurve = 690L,
	dispidGluBeginTrim = 691L,
	dispidGluBeginCurve = 692L,
	dispidGluEndSurface = 693L,
	dispidGluEndTrim = 694L,
	dispidGluPwlCurve = 695L,
	dispidGluNurbsCurve = 696L,
	dispidGluNurbsSurface = 697L,
	dispidGluNurbsProperty = 698L,
	dispidGluGetNurbsProperty = 699L,
	dispidGetMap = 700L,
	dispidEvalCoord1 = 701L,
	dispidEvalCoord2 = 702L,
	dispidEvalMesh1 = 703L,
	dispidEvalMesh2 = 704L,
	dispidEvalPoint1 = 705L,
	dispidEvalPoint2 = 706L,
	dispidMap1 = 707L,
	dispidMap2 = 708L,
	dispidMapGrid1 = 709L,
	dispidMapGrid2 = 710L,
	dispidGetTexEnvfv = 711L,
	dispidGetTexGenfv = 712L,
	dispidGetTexLevelParameterfv = 713L,
	dispidGetTexParameterfv = 714L,
	dispidTexCoord1f = 715L,
	dispidTexCoord2f = 716L,
	dispidTexCoord3f = 717L,
	dispidTexCoord4f = 718L,
	dispidTexEnvf = 719L,
	dispidTexEnvfv = 720L,
	dispidTexGenf = 721L,
	dispidTexGenfv = 722L,
	dispidTexParameterf = 723L,
	dispidTexParameterfv = 724L,
	dispidTexImage1D = 725L,
	dispidTexImage2D = 726L,
	dispidPassThrough = 727L,
	eventidRender = 1L,
	eventidSetupRC = 2L,
	//}}AFX_DISP_ID
	};

};
