// friendly.c
// A more friendly OpenGL program 

#include <windows.h>	// Standard header for Windows
#include <gl\gl.h>		// OpenGL library
#include <gl\glaux.h>	// AUX library


// Called by AUX library to draw scene
void CALLBACK RenderScene(void)
	{
	// Set clear color to Blue
	glClearColor(0.0f, 0.0f, 1.0f, 1.0f);

	// Clear the window
	glClear(GL_COLOR_BUFFER_BIT);

	// Set current drawing color to red
	//		   R	 G	   B
	glColor3f(1.0f, 0.0f, 0.0f);

	// Draw a filled rectangle with current color
	glRectf(100.0f, 150.0f, 150.0f, 100.0f);

	glFlush();
	}



void main(void)
	{
	// AUX library window and mode setup
	auxInitDisplayMode(AUX_SINGLE | AUX_RGBA);
	auxInitPosition(100,100,250,250);
	auxInitWindow("My second OpenGL Program");

	// Set function to call when window needs updating
	auxMainLoop(RenderScene);
	}

