// TriangleView.h : interface of the CTriangleView class
//
/////////////////////////////////////////////////////////////////////////////

class CTriangleView : public CView
{
protected: // create from serialization only
	CTriangleView();
	DECLARE_DYNCREATE(CTriangleView)

// Attributes
public:
	CTriangleDoc* GetDocument();

	HGLRC m_hRC;	// Rendering Context
	HDC m_hDC;		// Device Context

	CPalette m_GLPalette;	// Logical Palette

// Operations
public:
protected:
	void InitializePalette(void);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTriangleView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTriangleView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CTriangleView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnEffectsCullback();
	afx_msg void OnEffectsDepthtest();
	afx_msg void OnEffectsOutlineback();
	afx_msg void OnUpdateEffectsCullback(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEffectsDepthtest(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEffectsOutlineback(CCmdUI* pCmdUI);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in TriangleView.cpp
inline CTriangleDoc* CTriangleView::GetDocument()
   { return (CTriangleDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
