//----------------------------------------------------------------------------
//  Project Slstbolt
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Slstbolt Application
//  FILE:         slstblta.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TSlstboltApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(slstblta_h)              // Sentry, use file only if it's not already included.
#define slstblta_h

#include <owl/opensave.h>


#include "slstblta.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();
};    //{{TSDIDecFrame}}


//{{TApplication = TSlstboltApp}}
class TSlstboltApp : public TApplication {
  private:


  public:
    TSlstboltApp();
    virtual ~TSlstboltApp();

    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.
    void OpenFile(const char* fileName = 0);

//{{TSlstboltAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
//{{TSlstboltAppVIRTUAL_END}}

//{{TSlstboltAppRSP_TBL_BEGIN}}
  protected:
    void CmFileNew();
    void CmFileOpen();
    void CmHelpAbout();
//{{TSlstboltAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TSlstboltApp);
};    //{{TSlstboltApp}}


#endif  // slstblta_h sentry.
