//----------------------------------------------------------------------------
//  Project Slstbolt
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Slstbolt Application
//  FILE:         slstbltw.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TSlstboltWindow (TWindow).
//
//----------------------------------------------------------------------------
#if !defined(slstbltw_h)              // Sentry, use file only if it's not already included.
#define slstbltw_h

#include "slstblta.rh"            // Definition of all resources.
#include <gl\gl.h>
#include <gl\glu.h>

//{{TWindow = TSlstboltWindow}}
class TSlstboltWindow : public TWindow {
  public:
    TSlstboltWindow(TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~TSlstboltWindow();

    HGLRC m_hRC;		// Rendering context
    HDC m_hDC;		// Device context
    TPalette *m_pPalette;	// 3-3-2 Palette

    void SetupPalette(HDC hDC);


//{{TSlstboltWindowRSP_TBL_BEGIN}}
  protected:
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  bool EvQueryNewPalette();
  void EvPaletteChanged(THandle hWndPalChg);
//{{TSlstboltWindowRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TSlstboltWindow);
};    //{{TSlstboltWindow}}


#endif  // slstbltw_h sentry.
