//----------------------------------------------------------------------------
//  Project Oglview
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Oglview Application
//  FILE:         oglvwabd.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TOglviewAboutDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(oglvwabd_h)              // Sentry, use file only if it's not already included.
#define oglvwabd_h

#include <owl/static.h>

#include "oglvwapp.rh"                  // Definition of all resources.


//{{TDialog = TOglviewAboutDlg}}
class TOglviewAboutDlg : public TDialog {
  public:
    TOglviewAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);
    virtual ~TOglviewAboutDlg();

//{{TOglviewAboutDlgVIRTUAL_BEGIN}}
  public:
    void SetupWindow();
//{{TOglviewAboutDlgVIRTUAL_END}}

//{{TOglviewAboutDlgRSP_TBL_BEGIN}}
  protected:
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  bool EvQueryNewPalette();
  void EvPaletteChanged(THandle hWndPalChg);
  void CmFileopen();
  void CeFileopen(TCommandEnabler &tce);
  void CmFilesaveas();
  void CeFilesaveas(TCommandEnabler &tce);
//{{TOglviewAboutDlgRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TOglviewAboutDlg);
};    //{{TOglviewAboutDlg}}


// Reading the VERSIONINFO resource.
//
class TProjectRCVersion {
  public:
    TProjectRCVersion(TModule* module);
    virtual ~TProjectRCVersion();

    bool GetProductName(LPSTR& prodName);
    bool GetProductVersion(LPSTR& prodVersion);
    bool GetCopyright(LPSTR& copyright);
    bool GetDebug(LPSTR& debug);

  protected:
    uint8 far*  TransBlock;
    void far*   FVData;

  private:
    // Don't allow this object to be copied.
    //
    TProjectRCVersion(const TProjectRCVersion&);
    TProjectRCVersion& operator = (const TProjectRCVersion&);
};


#endif  // oglvwabd_h sentry.
