//----------------------------------------------------------------------------
//  Project Oglview
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Oglview Application
//  FILE:         oglvwapp.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TOglviewApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(oglvwapp_h)              // Sentry, use file only if it's not already included.
#define oglvwapp_h

#include <owl/opensave.h>


#include "oglvwapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();
};    //{{TSDIDecFrame}}


//{{TApplication = TOglviewApp}}
class TOglviewApp : public TApplication {
  private:


  public:
    TOglviewApp();
    virtual ~TOglviewApp();

    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.
    void OpenFile(const char* fileName = 0);

//{{TOglviewAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
//{{TOglviewAppVIRTUAL_END}}

//{{TOglviewAppRSP_TBL_BEGIN}}
  protected:
    void CmFileNew();
    void CmFileOpen();
    void CmHelpAbout();
//{{TOglviewAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TOglviewApp);
};    //{{TOglviewApp}}


#endif  // oglvwapp_h sentry.
