//----------------------------------------------------------------------------
//  Project Oglview
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Oglview Application
//  FILE:         oglvwwnd.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TOglviewWindow (TWindow).
//
//----------------------------------------------------------------------------
#if !defined(oglvwwnd_h)              // Sentry, use file only if it's not already included.
#define oglvwwnd_h

#include "oglvwapp.rh"            // Definition of all resources.
#include <gl\gl.h>
#include <gl\glu.h>

//{{TWindow = TOglviewWindow}}
class TOglviewWindow : public TWindow {
  public:
    TOglviewWindow(TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~TOglviewWindow();

    HGLRC m_hRC;		// Rendering context
    HDC m_hDC;		// Device context
    TPalette *m_pPalette;	// 3-3-2 Palette

    void SetupPalette(HDC hDC);
    

//{{TOglviewWindowRSP_TBL_BEGIN}}
  protected:
  void CmFileopen();
  void CeFileopen(TCommandEnabler &tce);
  void CmFilesaveas();
  void CeFilesaveas(TCommandEnabler &tce);
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  bool EvQueryNewPalette();
  void EvPaletteChanged(THandle hWndPalChg);
  void CmFileitem1();
//{{TOglviewWindowRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TOglviewWindow);
};    //{{TOglviewWindow}}


#endif  // oglvwwnd_h sentry.
