//----------------------------------------------------------------------------
//  Project Nurbs
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Nurbs Application
//  FILE:         nrbsabtd.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TNurbsAboutDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(nrbsabtd_h)              // Sentry, use file only if it's not already included.
#define nrbsabtd_h

#include <owl/static.h>

#include "nurbsapp.rh"                  // Definition of all resources.


//{{TDialog = TNurbsAboutDlg}}
class TNurbsAboutDlg : public TDialog {
  public:
    TNurbsAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);
    virtual ~TNurbsAboutDlg();

//{{TNurbsAboutDlgVIRTUAL_BEGIN}}
  public:
    void SetupWindow();
//{{TNurbsAboutDlgVIRTUAL_END}}
};    //{{TNurbsAboutDlg}}


// Reading the VERSIONINFO resource.
//
class TProjectRCVersion {
  public:
    TProjectRCVersion(TModule* module);
    virtual ~TProjectRCVersion();

    bool GetProductName(LPSTR& prodName);
    bool GetProductVersion(LPSTR& prodVersion);
    bool GetCopyright(LPSTR& copyright);
    bool GetDebug(LPSTR& debug);

  protected:
    uint8 far*  TransBlock;
    void far*   FVData;

  private:
    // Don't allow this object to be copied.
    //
    TProjectRCVersion(const TProjectRCVersion&);
    TProjectRCVersion& operator = (const TProjectRCVersion&);
};


#endif  // nrbsabtd_h sentry.
