//----------------------------------------------------------------------------
//  Project Nurbs
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Nurbs Application
//  FILE:         nrbswndw.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TNurbsWindow (TWindow).
//
//----------------------------------------------------------------------------
#if !defined(nrbswndw_h)              // Sentry, use file only if it's not already included.
#define nrbswndw_h

#include "nurbsapp.rh"            // Definition of all resources.
#include <gl\gl.h>
#include <gl\glu.h>

//{{TWindow = TNurbsWindow}}
class TNurbsWindow : public TWindow {
  public:
    TNurbsWindow(TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~TNurbsWindow();

    HGLRC m_hRC;		// Rendering context
    HDC m_hDC;		// Device context
    TPalette *m_pPalette;	// 3-3-2 Palette

    void SetupPalette(HDC hDC);


//{{TNurbsWindowRSP_TBL_BEGIN}}
  protected:
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  void EvPaletteChanged(THandle hWndPalChg);
  bool EvQueryNewPalette();
//{{TNurbsWindowRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TNurbsWindow);
};    //{{TNurbsWindow}}


#endif  // nrbswndw_h sentry.
