//----------------------------------------------------------------------------
//  Project Nurbs
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Nurbs Application
//  FILE:         nurbsapp.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TNurbsApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(nurbsapp_h)              // Sentry, use file only if it's not already included.
#define nurbsapp_h

#include <owl/opensave.h>


#include "nurbsapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();
};    //{{TSDIDecFrame}}


//{{TApplication = TNurbsApp}}
class TNurbsApp : public TApplication {
  private:


  public:
    TNurbsApp();
    virtual ~TNurbsApp();

    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.
    void OpenFile(const char* fileName = 0);

//{{TNurbsAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
//{{TNurbsAppVIRTUAL_END}}

//{{TNurbsAppRSP_TBL_BEGIN}}
  protected:
    void CmFileNew();
    void CmFileOpen();
    void CmHelpAbout();
//{{TNurbsAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TNurbsApp);
};    //{{TNurbsApp}}


#endif  // nurbsapp_h sentry.
