//----------------------------------------------------------------------------
//  Project Triangle
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Triangle Application
//  FILE:         trnglapp.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TTriangleApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(trnglapp_h)              // Sentry, use file only if it's not already included.
#define trnglapp_h

#include <owl/opensave.h>

#include "trnglapp.rh"            // Definition of all resources.

//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();


};    //{{TSDIDecFrame}}


//{{TApplication = TTriangleApp}}
class TTriangleApp : public TApplication {
  private:


  public:
    TTriangleApp();
    virtual ~TTriangleApp();

    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.
    void OpenFile(const char* fileName = 0);

//{{TTriangleAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
//{{TTriangleAppVIRTUAL_END}}

//{{TTriangleAppRSP_TBL_BEGIN}}
  protected:
    void CmFileNew();
    void CmFileOpen();
    void CmHelpAbout();
//{{TTriangleAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TTriangleApp);
};    //{{TTriangleApp}}


#endif  // trnglapp_h sentry.
