//----------------------------------------------------------------------------
//  Project Triangle
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Triangle Application
//  FILE:         trnglwnd.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TTriangleWindow (TWindow).
//
//----------------------------------------------------------------------------
#if !defined(trnglwnd_h)              // Sentry, use file only if it's not already included.
#define trnglwnd_h

#include "trnglapp.rh"            // Definition of all resources.


//{{TWindow = TTriangleWindow}}
class TTriangleWindow : public TWindow {
  public:
    TTriangleWindow(TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~TTriangleWindow();

    HGLRC m_hRC;		// Rendering context
    HDC m_hDC;		// Device context
    TPalette *m_pPalette;	// 3-3-2 Palette

    void SetupPalette(HDC hDC);

//{{TTriangleWindowRSP_TBL_BEGIN}}
  protected:
  void CmCull();
  void CeCull(TCommandEnabler &tce);
  void CmDepth_test();
  void CeDepth_test(TCommandEnabler &tce);
  void CmOutline_back();
  void CeOutline_back(TCommandEnabler &tce);
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  bool EvQueryNewPalette();
  void EvPaletteChanged(THandle hWndPalChg);
  void EvKeyDown(uint key, uint repeatCount, uint flags);
//{{TTriangleWindowRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TTriangleWindow);
};    //{{TTriangleWindow}}


#endif  // trnglwnd_h sentry.
