//----------------------------------------------------------------------------
//  Project Atom
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Atom Application
//  FILE:         atmabtdl.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TAtomAboutDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(atmabtdl_h)              // Sentry, use file only if it's not already included.
#define atmabtdl_h

#include <owl/static.h>

#include "atomapp.rh"                  // Definition of all resources.


//{{TDialog = TAtomAboutDlg}}
class TAtomAboutDlg : public TDialog {
  public:
    TAtomAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);
    virtual ~TAtomAboutDlg();

//{{TAtomAboutDlgVIRTUAL_BEGIN}}
  public:
    void SetupWindow();
//{{TAtomAboutDlgVIRTUAL_END}}
};    //{{TAtomAboutDlg}}


// Reading the VERSIONINFO resource.
//
class TProjectRCVersion {
  public:
    TProjectRCVersion(TModule* module);
    virtual ~TProjectRCVersion();

    bool GetProductName(LPSTR& prodName);
    bool GetProductVersion(LPSTR& prodVersion);
    bool GetCopyright(LPSTR& copyright);
    bool GetDebug(LPSTR& debug);

  protected:
    uint8 far*  TransBlock;
    void far*   FVData;

  private:
    // Don't allow this object to be copied.
    //
    TProjectRCVersion(const TProjectRCVersion&);
    TProjectRCVersion& operator = (const TProjectRCVersion&);
};


#endif  // atmabtdl_h sentry.
