//----------------------------------------------------------------------------
//  Project Atom
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Atom Application
//  FILE:         atomapp.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TAtomApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(atomapp_h)              // Sentry, use file only if it's not already included.
#define atomapp_h

#include <owl/opensave.h>


#include "atomapp.rh"            // Definition of all resources.
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>

//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();
};    //{{TSDIDecFrame}}


//{{TApplication = TAtomApp}}
class TAtomApp : public TApplication {
  private:


  public:
    TAtomApp();
    virtual ~TAtomApp();

    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.
    void OpenFile(const char* fileName = 0);

//{{TAtomAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
//{{TAtomAppVIRTUAL_END}}

//{{TAtomAppRSP_TBL_BEGIN}}
  protected:
    void CmFileNew();
    void CmFileOpen();
    void CmHelpAbout();
//{{TAtomAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TAtomApp);
};    //{{TAtomApp}}


#endif  // atomapp_h sentry.
