//----------------------------------------------------------------------------
//  Project Atom
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Atom Application
//  FILE:         atomwndw.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TAtomWindow (TWindow).
//
//----------------------------------------------------------------------------
#if !defined(atomwndw_h)              // Sentry, use file only if it's not already included.
#define atomwndw_h

#include "atomapp.rh"            // Definition of all resources.


//{{TWindow = TAtomWindow}}
class TAtomWindow : public TWindow {
  public:
    TAtomWindow(TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~TAtomWindow();

    HGLRC m_hRC;		// Rendering context
    HDC m_hDC;		// Device context
    TPalette *m_pPalette;	// 3-3-2 Palette

    void SetupPalette(HDC hDC);
        

//{{TAtomWindowRSP_TBL_BEGIN}}
  protected:
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  bool EvQueryNewPalette();
  void EvPaletteChanged(THandle hWndPalChg);
  void EvTimer(uint timerId);
//{{TAtomWindowRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TAtomWindow);
};    //{{TAtomWindow}}


#endif  // atomwndw_h sentry.
