//----------------------------------------------------------------------------
//  Project RGBTrngl
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    RGBTrngl Application
//  FILE:         rgbtrnad.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TRGBTrnglAboutDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(rgbtrnad_h)              // Sentry, use file only if it's not already included.
#define rgbtrnad_h

#include <owl/static.h>

#include "rgbtrnga.rh"                  // Definition of all resources.


//{{TDialog = TRGBTrnglAboutDlg}}
class TRGBTrnglAboutDlg : public TDialog {
  public:
    TRGBTrnglAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);
    virtual ~TRGBTrnglAboutDlg();

//{{TRGBTrnglAboutDlgVIRTUAL_BEGIN}}
  public:
    void SetupWindow();
//{{TRGBTrnglAboutDlgVIRTUAL_END}}

//{{TRGBTrnglAboutDlgRSP_TBL_BEGIN}}
  protected:
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  void EvPaletteChanged(THandle hWndPalChg);
  bool EvQueryNewPalette();
//{{TRGBTrnglAboutDlgRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TRGBTrnglAboutDlg);
};    //{{TRGBTrnglAboutDlg}}


// Reading the VERSIONINFO resource.
//
class TProjectRCVersion {
  public:
    TProjectRCVersion(TModule* module);
    virtual ~TProjectRCVersion();

    bool GetProductName(LPSTR& prodName);
    bool GetProductVersion(LPSTR& prodVersion);
    bool GetCopyright(LPSTR& copyright);
    bool GetDebug(LPSTR& debug);

  protected:
    uint8 far*  TransBlock;
    void far*   FVData;

  private:
    // Don't allow this object to be copied.
    //
    TProjectRCVersion(const TProjectRCVersion&);
    TProjectRCVersion& operator = (const TProjectRCVersion&);
};


#endif  // rgbtrnad_h sentry.
