//----------------------------------------------------------------------------
//  Project RGBTrngl
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    RGBTrngl Application
//  FILE:         rgbtrnga.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TRGBTrnglApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(rgbtrnga_h)              // Sentry, use file only if it's not already included.
#define rgbtrnga_h

#include <owl/opensave.h>


#include "rgbtrnga.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();
};    //{{TSDIDecFrame}}


//{{TApplication = TRGBTrnglApp}}
class TRGBTrnglApp : public TApplication {
  private:


  public:
    TRGBTrnglApp();
    virtual ~TRGBTrnglApp();

    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.
    void OpenFile(const char* fileName = 0);

//{{TRGBTrnglAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
//{{TRGBTrnglAppVIRTUAL_END}}

//{{TRGBTrnglAppRSP_TBL_BEGIN}}
  protected:
    void CmFileNew();
    void CmFileOpen();
    void CmHelpAbout();
//{{TRGBTrnglAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TRGBTrnglApp);
};    //{{TRGBTrnglApp}}


#endif  // rgbtrnga_h sentry.
