//----------------------------------------------------------------------------
//  Project RGBTrngl
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    RGBTrngl Application
//  FILE:         rgbtrngw.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TRGBTrnglWindow (TWindow).
//
//----------------------------------------------------------------------------
#if !defined(rgbtrngw_h)              // Sentry, use file only if it's not already included.
#define rgbtrngw_h

#include "rgbtrnga.rh"            // Definition of all resources.
#include <gl/gl.h>
#include <gl/glu.h>


//{{TWindow = TRGBTrnglWindow}}
class TRGBTrnglWindow : public TWindow {
  public:
    TRGBTrnglWindow(TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~TRGBTrnglWindow();

    HGLRC m_hRC;		// Rendering context
    HDC m_hDC;		// Device context
    TPalette *m_pPalette;	// 3-3-2 Palette

    void SetupPalette(HDC hDC);


//{{TRGBTrnglWindowRSP_TBL_BEGIN}}
  protected:
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  void EvPaletteChanged(THandle hWndPalChg);
  bool EvQueryNewPalette();
//{{TRGBTrnglWindowRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TRGBTrnglWindow);
};    //{{TRGBTrnglWindow}}


#endif  // rgbtrngw_h sentry.
