//----------------------------------------------------------------------------
//  Project Shadow
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Shadow Application
//  FILE:         shadwapp.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TShadowApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(shadwapp_h)              // Sentry, use file only if it's not already included.
#define shadwapp_h

#include <owl/opensave.h>


#include "shadwapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();
};    //{{TSDIDecFrame}}


//{{TApplication = TShadowApp}}
class TShadowApp : public TApplication {
  private:


  public:
    TShadowApp();
    virtual ~TShadowApp();

    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.
    void OpenFile(const char* fileName = 0);

//{{TShadowAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
//{{TShadowAppVIRTUAL_END}}

//{{TShadowAppRSP_TBL_BEGIN}}
  protected:
    void CmFileNew();
    void CmFileOpen();
    void CmHelpAbout();
//{{TShadowAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TShadowApp);
};    //{{TShadowApp}}


#endif  // shadwapp_h sentry.
