//----------------------------------------------------------------------------
//  Project Shadow
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Shadow Application
//  FILE:         shdwabtd.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TShadowAboutDlg (TDialog).
//
//----------------------------------------------------------------------------
#if !defined(shdwabtd_h)              // Sentry, use file only if it's not already included.
#define shdwabtd_h

#include <owl/static.h>

#include "shadwapp.rh"                  // Definition of all resources.


//{{TDialog = TShadowAboutDlg}}
class TShadowAboutDlg : public TDialog {
  public:
    TShadowAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);
    virtual ~TShadowAboutDlg();

//{{TShadowAboutDlgVIRTUAL_BEGIN}}
  public:
    void SetupWindow();
//{{TShadowAboutDlgVIRTUAL_END}}
};    //{{TShadowAboutDlg}}


// Reading the VERSIONINFO resource.
//
class TProjectRCVersion {
  public:
    TProjectRCVersion(TModule* module);
    virtual ~TProjectRCVersion();

    bool GetProductName(LPSTR& prodName);
    bool GetProductVersion(LPSTR& prodVersion);
    bool GetCopyright(LPSTR& copyright);
    bool GetDebug(LPSTR& debug);

  protected:
    uint8 far*  TransBlock;
    void far*   FVData;

  private:
    // Don't allow this object to be copied.
    //
    TProjectRCVersion(const TProjectRCVersion&);
    TProjectRCVersion& operator = (const TProjectRCVersion&);
};


#endif  // shdwabtd_h sentry.
