//----------------------------------------------------------------------------
//  Project Shadow
//  Waite Group Press
//  Copyright  1996. All Rights Reserved.
//
//  SUBSYSTEM:    Shadow Application
//  FILE:         shdwwndw.h
//  AUTHOR:       Richard S. Wright Jr.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TShadowWindow (TWindow).
//
//----------------------------------------------------------------------------
#if !defined(shdwwndw_h)              // Sentry, use file only if it's not already included.
#define shdwwndw_h

#include "shadwapp.rh"            // Definition of all resources.
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>

//{{TWindow = TShadowWindow}}
class TShadowWindow : public TWindow {
  public:
    TShadowWindow(TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~TShadowWindow();

    HGLRC m_hRC;		// Rendering context
    HDC m_hDC;		// Device context
    TPalette *m_pPalette;	// 3-3-2 Palette

    void SetupPalette(HDC hDC);

//{{TShadowWindowRSP_TBL_BEGIN}}
  protected:
  int EvCreate(CREATESTRUCT far& createStruct);
  void EvDestroy();
  bool EvEraseBkgnd(HDC dc);
  void EvPaint();
  void EvSize(uint sizeType, TSize& size);
  void EvPaletteChanged(THandle hWndPalChg);
  bool EvQueryNewPalette();
  void EvKeyDown(uint key, uint repeatCount, uint flags);
//{{TShadowWindowRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TShadowWindow);
};    //{{TShadowWindow}}


#endif  // shdwwndw_h sentry.
